Package: seqPattern
Title: Visualising oligonucleotide patterns and motif occurrences
        across a set of sorted sequences
Version: 1.43.0
Date: 08-05-2015
Author: Vanja Haberle <vanja.haberle@gmail.com>
Maintainer: Vanja Haberle <vanja.haberle@gmail.com>
Imports: Biostrings, GenomicRanges, IRanges, KernSmooth, plotrix
Depends: methods, R (>= 2.15.0)
Suggests: BSgenome.Drerio.UCSC.danRer7, CAGEr, RUnit, BiocGenerics,
        BiocStyle
Enhances: parallel
Description: Visualising oligonucleotide patterns and sequence motifs
        occurrences across a large set of sequences centred at a common
        reference point and sorted by a user defined feature.
License: GPL-3
biocViews: Visualization, SequenceMatching
Collate: MotifScanningFunctions.R MotifScanningMethods.R
        PatternOccurrenceFunctions.R PatternOccurrenceMethods.R
        PlottingFunctions.R PlottingMethods.R
git_url: https://git.bioconductor.org/packages/seqPattern
git_branch: devel
git_last_commit: 4b1e21f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-11-01 00:09:51 UTC; biocbuild

import(methods)
import(Biostrings)
import(GenomicRanges)
import(IRanges)
import(KernSmooth)

importFrom(plotrix, color.legend)

exportMethods(motifScanHits, motifScanScores, getPatternOccurrenceList,
plotPatternDensityMap, plotPatternOccurrenceAverage, plotMotifDensityMap,
plotMotifOccurrenceAverage, plotMotifScanScores)

### R code from vignette source 'seqPattern.Rnw'

###################################################
### code chunk number 1: style-Sweave
###################################################
BiocStyle::latex()


###################################################
### code chunk number 2: setup
###################################################
options(width = 80)
olocale=Sys.setlocale(locale="C")


###################################################
### code chunk number 3: seqPattern.Rnw:93-94
###################################################
library(seqPattern)


###################################################
### code chunk number 4: seqPattern.Rnw:106-109
###################################################
data(zebrafishPromoters)
zebrafishPromoters
head(zebrafishPromoters@elementMetadata)


###################################################
### code chunk number 5: seqPattern.Rnw:125-127
###################################################
data(zebrafishPromoters24h)
head(zebrafishPromoters24h)


###################################################
### code chunk number 6: seqPattern.Rnw:150-151
###################################################
library(BSgenome.Drerio.UCSC.danRer7)


###################################################
### code chunk number 7: seqPattern.Rnw:158-161
###################################################
data(zebrafishPromoters24h)
nrow(zebrafishPromoters24h)
head(zebrafishPromoters24h)


###################################################
### code chunk number 8: seqPattern.Rnw:176-188
###################################################
# create GRanges of dominant TSS position with associated metadata
zebrafishPromotersTSS <- GRanges(seqnames = zebrafishPromoters24h$chr,
            ranges = IRanges(start = zebrafishPromoters24h$dominantTSS, 
            end = zebrafishPromoters24h$dominantTSS), 
            strand = zebrafishPromoters24h$strand, 
            interquantileWidth = zebrafishPromoters24h$interquantileWidth, 
            seqlengths = seqlengths(Drerio))
# get regions flanking TSS - 400 bp upstream and 800 bp downstream
zebrafishPromotersTSSflank <- promoters(zebrafishPromotersTSS, upstream = 400, 
                                        downstream = 800)
# obtain genomic sequence of flanking regions
zebrafishPromotersTSSflankSeq <- getSeq(Drerio, zebrafishPromotersTSSflank)


###################################################
### code chunk number 9: seqPattern.Rnw:204-208 (eval = FALSE)
###################################################
## plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             patterns = c("AA", "TA", "CG", "GC"), 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
##             flankUp = 400, flankDown = 800, color = "blue")


###################################################
### code chunk number 10: seqPattern.Rnw:264-268 (eval = FALSE)
###################################################
## plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             patterns = c("AA", "TA", "CG", "GC"), 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
##             flankUp = 400, flankDown = 800, useMulticore = TRUE, nrCores = 4)


###################################################
### code chunk number 11: seqPattern.Rnw:310-314 (eval = FALSE)
###################################################
## plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             patterns = c("WW", "SS"), 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
##             flankUp = 400, flankDown = 800, color = "cyan", labelCol = "white")


###################################################
### code chunk number 12: seqPattern.Rnw:333-345 (eval = FALSE)
###################################################
## # make index of sharp and broad promoters
## sIdx <- zebrafishPromotersTSSflank$interquantileWidth <= 9
## bIdx <- zebrafishPromotersTSSflank$interquantileWidth > 9
## # plot average dinucleotide profile for sharp promoters
## par(mfrow = c(1,2), mar = c(4.5,4,1,1))
## plotPatternOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[sIdx], 
##             patterns = c("WW", "SS"), flankUp = 400, flankDown = 800, 
##             smoothingWindow = 3, color = c("red3", "blue3"), cex.axis = 0.9)
## # plot average dinucleotide profile for broad promoters
## plotPatternOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[bIdx], 
##             patterns = c("WW", "SS"), flankUp = 400, flankDown = 800, 
##             smoothingWindow = 3, color = c("red3", "blue3"), cex.axis = 0.9)


###################################################
### code chunk number 13: seqPattern.Rnw:370-375
###################################################
# get regions flanking dominant TSS - 200bp upstream and downstream
zebrafishPromotersTSSflank <- promoters(zebrafishPromotersTSS, upstream = 200, 
                                        downstream = 200)
# obtain genomic sequence of the flanking regions
zebrafishPromotersTSSflankSeq <- getSeq(Drerio, zebrafishPromotersTSSflank)


###################################################
### code chunk number 14: seqPattern.Rnw:377-389 (eval = FALSE)
###################################################
## # plot density of TATA-box consensus sequence in pink
## plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             patterns = c("TATAWAWR", "YWTWTATA"), 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
##             flankUp = 200, flankDown = 200, nBin = c(400, 10000), 
##             bandWidth = c(1,6), color = "pink", addPatternLabel = FALSE)
##  # plot density of GC-box consensus sequence in purple
## plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             patterns = c("RGGMGGR", "YCCKCCY"), 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
##             flankUp = 200, flankDown = 200, nBin = c(400, 10000), 
##             bandWidth = c(1,6), color = "purple", addPatternLabel = FALSE)


###################################################
### code chunk number 15: seqPattern.Rnw:429-431
###################################################
data(TBPpwm)
TBPpwm


###################################################
### code chunk number 16: seqPattern.Rnw:439-443 (eval = FALSE)
###################################################
## plotMotifDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             motifPWM = TBPpwm, minScore = "90%", 
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
##             flankUp = 200, flankDown = 200, color = "red")


###################################################
### code chunk number 17: seqPattern.Rnw:450-454 (eval = FALSE)
###################################################
## plotMotifScanScores(regionsSeq = zebrafishPromotersTSSflankSeq, 
##             motifPWM = TBPpwm,
##             seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
##             flankUp = 200, flankDown = 200)


###################################################
### code chunk number 18: seqPattern.Rnw:481-494 (eval = FALSE)
###################################################
## # make index of sharp and broad promoters
## sIdx <- zebrafishPromotersTSSflank$interquantileWidth <= 9
## bIdx <- zebrafishPromotersTSSflank$interquantileWidth > 9
## # plot average motif occurrence profile for sharp promoters
## plotMotifOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[sIdx], 
##             motifPWM = TBPpwm, minScore = "90%", flankUp = 200, flankDown = 200, 
##             smoothingWindow = 3, color = c("red3"), cex.axis = 0.9)
## # add average motif occurrence profile for broad promoters to the existing plot
## plotMotifOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[bIdx], 
##             motifPWM = TBPpwm, minScore = "90%", flankUp = 200, flankDown = 200, 
##             smoothingWindow = 3, color = c("blue3"), add = TRUE)
## legend("topright", legend = c("sharp", "broad"), col = c("red3", "blue3"), 
## bty = "n", lwd = 1)


###################################################
### code chunk number 19: seqPattern.Rnw:519-524
###################################################
motifOccurrence <- motifScanHits(regionsSeq = 
            zebrafishPromotersTSSflankSeq[1:50], 
            motifPWM = TBPpwm, minScore = "90%", seqOrder = 
            order(zebrafishPromotersTSSflank$interquantileWidth[1:50]))
head(motifOccurrence)


###################################################
### code chunk number 20: seqPattern.Rnw:538-543
###################################################
scanScores <- motifScanScores(regionsSeq = zebrafishPromotersTSSflankSeq[1:50], 
            motifPWM = TBPpwm, seqOrder = 
            order(zebrafishPromotersTSSflank$interquantileWidth[1:50]))
dim(scanScores)
scanScores[1:6,1:6]


###################################################
### code chunk number 21: seqPattern.Rnw:552-553
###################################################
sessionInfo()

.get.pattern.occurence.melted <- function(pattern, seq, seqOrder){
    pattern.matches <- vmatchPattern(pattern=pattern, subject=seq, fixed=FALSE)
    pattern.starts <- startIndex(pattern.matches)
    pattern.starts <- pattern.starts[seqOrder]
    non.zero.idx <- which(unlist(lapply(pattern.starts, length))>0)
    pattern.matrix.melt <- do.call(rbind, lapply(as.list(non.zero.idx),
        function(n) {
            data.frame(sequence = n, position = pattern.starts[[n]], value = 1)
        }))
    return(pattern.matrix.melt)
}

test_.get.pattern.occurence.melted <- function(){
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEquals(seqPattern:::.get.pattern.occurence.melted(pattern = "TCTGA",
    seq = zebrafishPromoters[1:5], seqOrder = c(1,4,2,3,5)),
    data.frame(sequence = as.integer(c(1,2,3,4,4,4,4)),
    position = as.integer(c(565,987,311,120,372,592,930)), value = rep(1,7)))
}

setGeneric(
name="getPatternOccurrenceList",
def=function(regionsSeq, patterns, seqOrder = c(1:length(regionsSeq)),
    useMulticore = FALSE, nrCores = NULL){
        standardGeneric("getPatternOccurrenceList")
    }
)

setMethod("getPatternOccurrenceList",
signature(regionsSeq = "DNAStringSet"),
function(regionsSeq, patterns, seqOrder = c(1:length(regionsSeq)),
    useMulticore = FALSE, nrCores = NULL){
        
        pt <- .Platform$OS.type
        if(useMulticore == TRUE){
            if(pt == "unix"){
                if("parallel" %in% rownames(installed.packages()) == FALSE){
                    stop("Cannot use multicore because package 'parallel' is 
                    not installed!")
                }else{
                    library(parallel)
                    if(is.null(nrCores)){
                        nrCores <- detectCores()
                    }
                }
            }else{
                useMulticore = FALSE
                warning("Multicore is not supported on non-Unix platforms! 
                Setting useMulticore=FALSE")
            }
        }
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the same 
            length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }
        if(length(patterns) == 0){
            stop("At least one pattern needs to be specified!")
        }
        
        regionsSeq <- DNAStringSet(gsub("N", "+", regionsSeq))
        
        if(useMulticore == TRUE){
            patterns.occurence.melted.list <- mclapply(as.list(patterns),
                function(x){
                    .get.pattern.occurence.melted(pattern = x, seq = regionsSeq,
                    seqOrder = seqOrder)
                }, mc.cores = nrCores)
        }else{
            patterns.occurence.melted.list <- lapply(as.list(patterns),
                function(x){
                    .get.pattern.occurence.melted(pattern = x, seq = regionsSeq,
                    seqOrder = seqOrder)
                })
        }
        
        names(patterns.occurence.melted.list) <- patterns
        return(patterns.occurence.melted.list)
    }
)

.smoothScatter <- function(x, y=NULL, map, nbin=128, bandwidth,
colramp=colorRampPalette(c("white", blues9)), nrpoints=100, pch=".", cex=1,
col="black", transformation=function(x) x^.25, max.value=NULL, postPlotHook=box,
xlab=NULL, ylab=NULL, xlim, ylim, xaxs=par("xaxs"), yaxs=par("yaxs"), ...){
    
    if (!is.numeric(nrpoints) | (nrpoints<0) | (length(nrpoints)!=1))
    stop("'nrpoints' should be numeric scalar with value >= 0.")
    
    ## similar as in plot.default
    xlabel <- if (!missing(x)) deparse(substitute(x))
    ylabel <- if (!missing(y)) deparse(substitute(y))
    xy <- xy.coords(x, y, xlabel, ylabel)
    xlab <- if (is.null(xlab)) xy$xlab else xlab
    ylab <- if (is.null(ylab)) xy$ylab else ylab
    
    ## eliminate non-finite (incl. NA) values
    x <- cbind(xy$x, xy$y)[ is.finite(xy$x) & is.finite(xy$y), , drop = FALSE]

    ## xlim and ylim
    if(!missing(xlim)) {
        stopifnot(is.numeric(xlim), length(xlim)==2, is.finite(xlim))
        x <- x[ min(xlim) <= x[,1] & x[,1] <= max(xlim), ]
    } else {
        xlim <- range(x[,1])
    }
    if(!missing(ylim)) {
        stopifnot(is.numeric(ylim), length(ylim)==2, is.finite(ylim))
        x <- x[ min(ylim) <= x[,2] & x[,2] <= max(ylim), ]
    } else {
        ylim <- range(x[,2])
    }
    
    ## create density map [ code in --> ../../grDevices/R/smooth2d.R ]:
    xm <- map$x1
    ym <- map$x2
    dens <- map$fhat
    dens[] <- transformation(dens)

    breaks <- seq(0, transformation(max.value), length.out=257)
    
    ## plot color image
    image(xm, ym, z=dens, col=colramp(256), breaks=breaks, xlab=xlab, ylab=ylab,
        xlim=xlim, ylim=ylim, xaxs=xaxs, yaxs=yaxs, ...)
    if(!is.null(postPlotHook))
    postPlotHook()
    
    ## plot selection of dots
    if (nrpoints > 0) {
        nrpoints <- min(nrow(x), ceiling(nrpoints))
        ## we assume that map$x1 and map$x2 go linearly from
        ## their first to their last value in nbin steps
        stopifnot((nx <- length(xm)) == nrow(dens),
            (ny <- length(ym)) == ncol(dens))
        ixm <- 1L + as.integer((nx-1)*(x[,1]-xm[1])/(xm[nx]-xm[1]))
        iym <- 1L + as.integer((ny-1)*(x[,2]-ym[1])/(ym[ny]-ym[1]))
        sel <- order(dens[cbind(ixm, iym)])[seq_len(nrpoints)]
        points(x[sel,], pch=pch, cex=cex, col=col)
    }
}

.myColorPalette <- function(colorName){
    colors.df <- data.frame(midcol=c("palegreen","aquamarine","lightblue",
        "lavender","mistyrose","peachpuff","lightgoldenrod2","wheat2",
        "lightgray"), highcol=c("darkgreen","darkslategrey","blue4","purple4",
        "deeppink4","red4","darkorange4","salmon4","black"),
        stringsAsFactors = FALSE)
    rownames(colors.df) <- c("green","cyan","blue","purple","pink","red",
        "orange","brown","gray")
    c("white", colors.df[colorName,"midcol"], colors.df[colorName,"highcol"])
}

log5 <- function(x) {
    log10(x)/log10(5)
}

.pattern.smoothscatter <- function(melted, orig, patterns, flankUp=NULL,
flankDown=NULL, bw=NULL, nbin=NULL, color='blue', transf=NULL, xTicks=NULL,
xTicksAt=NULL, xLabel="", yTicks=NULL, yTicksAt=NULL, yLabel="", cex.axis=8,
plot.scale=TRUE, scale.length=NULL, scale.width=10, add.label=TRUE, cex.label=8,
label.col='black', addReferenceLine=TRUE, plotColorLegend=TRUE, out,
plot.width=2000, plot.height=2000, useMulticore=FALSE, nrCores=NULL){
    
    
    mycols <- .myColorPalette(color)

    flank <- width(orig)[1]
    nr.seq <- length(orig)
    
    scale.factor <- 2*log5(20)*log5(100)/log5(flank/2) - 2*log5(4)

    if(length(nbin) == 0){
        nbin <- c(round(flank*scale.factor), length(orig))
    }
    if(length(bw) == 0){
        bw = c(3/scale.factor,3)
    }
    
    sums <- vector()
    for(di in patterns) {
        melted[[di]]$sequence <- length(orig) + 1 - melted[[di]]$sequence
        sums <- c(sums, sum(melted[[di]][,3]))
    }
    names(sums) <- patterns
    
    message("\nCalculating density...")

    if(useMulticore){
        a0 <- mclapply(as.list(patterns), function(di){
            bkde2D(melted[[di]][,c(2,1)], bandwidth=bw, gridsize=nbin);
        }, mc.cores = nrCores)
        names(a0) <- patterns
    }else{
        a0 <- list()
        for(di in patterns){
            message("->", di)
            a0[[di]] <- bkde2D(melted[[di]][,c(2,1)],bandwidth=bw,gridsize=nbin)
        }
    }
    
    d <- vector()
    a <- list()
    for(di in patterns){
        a[[di]] <- a0[[di]]$fhat
        d <- c(d, max(a[[di]]))
    }
    max.value <- max(d*sums)/sums
    names(max.value) <- patterns
    
    if(length(transf) == 0){
        transf <- function(x) {x^(1/3)}
        untransf <- function(x) {x^3}
    }
    
    if(length(xTicks) == 0){
        xTicks <- c(-1*flankUp, -1*flankUp/2, 0, flankDown/2, flankDown)
        xTicksAt <- cumsum(c(0.5, flankUp/2, flankUp/2, flankDown/2-1,
            flankDown/2))
    }
    
    cols.to.draw <- c(0:(flank-1))
    rows.to.draw <- 1:length(orig)
    
    message("\nPlotting...")
    
    if(useMulticore){
        
        mclapply(as.list(patterns), function(di){
            outfile <- paste(out,di, "png", sep=".")
            png(filename=outfile, width = plot.width, height = plot.height)
            par(mar = c(12, 8.5, 2, 8.5))
            dinuc.subset <- melted[[di]]
            
            .smoothScatter(x=dinuc.subset$position-cols.to.draw[1],
            y=max(rows.to.draw)+1-dinuc.subset$sequence, map=a0[[di]],
            axes=FALSE, xaxs="i", yaxs="i", xlab=xLabel, nrpoints=0,
            ylab=yLabel, xlim=c(0.5,flank -0.5), main='', bandwidth=bw,
            nbin=nbin, colramp=colorRampPalette(mycols), transformation=transf,
            max.value=max.value[di], pch=20, cex=0.8, col="gray",
            cex.main=1.5, cex.lab = 1.2)
            
            if(length(xTicks) > 0){
                axis(1, at=xTicksAt, labels=xTicks, cex.axis=cex.axis, padj=1,
                lwd=6, tcl=-1)
            }
            if(length(yTicks) > 0){
                axis(2, at=yTicksAt, labels=yTicks, cex.axis=cex.axis, las=1,
                lwd=6, tcl=-1)
            }
            box(lwd = 6)
            if(plot.scale){
                if(length(scale.length) == 0){
                    scale.length = flank/5
                }
                lines(c(0.03*flank/2,0.03*flank/2 + scale.length),
                    c(0.03*max(dinuc.subset$sequence), 0.03*
                    max(dinuc.subset$sequence)), lwd=scale.width, col=label.col)
                text(x=0.03*flank/2 + scale.length/2,
                    y=0.06*max(dinuc.subset$sequence),
                    labels=paste(round(scale.length), 'bp', sep=''),
                    cex=cex.label, adj=c(0.5,0), col=label.col, font=2)
            }
            if(add.label){
                text(x=0.02*flank/2, y=0.98*max(dinuc.subset$sequence),
                labels=di, cex=cex.label, adj=c(0,1), col=label.col, font=2)
            }
            if(addReferenceLine){
                abline(v=flankUp+0.5, lty="dashed", lwd=6)
            }
            dev.off()
        })
        
    }else{
        
        for (di in patterns){
            message("->", di)
            outfile <- paste(out,di,"png",sep=".")
            png(filename=outfile, width=plot.width, height=plot.height)
            par(mar=c(12, 8.5, 2, 8.5))
            dinuc.subset=melted[[di]]
            
            .smoothScatter(x=dinuc.subset$position-cols.to.draw[1],
            y=max(rows.to.draw)+1-dinuc.subset$sequence, map=a0[[di]],
            axes=FALSE, xaxs="i", yaxs="i", xlab=xLabel,nrpoints=0,
            ylab=yLabel, xlim=c(0.5,flank-0.5), main='', bandwidth=bw,
            nbin=nbin, colramp=colorRampPalette(mycols), transformation=transf,
            max.value=max.value[di], pch=20, cex=0.8,col="gray",
            cex.main=1.5, cex.lab=1.2)
            
            if(length(xTicks) > 0){
                axis(1, at=xTicksAt, labels=xTicks, cex.axis=cex.axis, padj=1,
                lwd=6, tcl=-1)
            }
            if(length(yTicks) > 0){
                axis(2, at=yTicksAt, labels=yTicks, cex.axis=cex.axis, las=1,
                lwd=6, tcl=-1)
            }
            box(lwd = 6)
            if(plot.scale){
                if(length(scale.length) == 0){
                    scale.length = flank/5
                }
                lines(c(0.03*flank/2,0.03*flank/2 + scale.length),
                c(0.03*max(dinuc.subset$sequence), 0.03*
                max(dinuc.subset$sequence)), lwd=scale.width, col=label.col)
                text(x=0.03*flank/2 + scale.length/2,
                y=0.06*max(dinuc.subset$sequence),
                labels=paste(round(scale.length), 'bp', sep=''),
                cex=cex.label, adj=c(0.5,0), col=label.col, font=2)
            }
            if(add.label){
                text(x=0.02*flank/2, y=0.98*max(dinuc.subset$sequence),
                labels=di, cex=cex.label, adj=c(0,1), col=label.col, font=2)
            }
            if(addReferenceLine){
                abline(v=flankUp+0.5, lty="dashed", lwd=6)
            }
            dev.off()
        }
    }
    
    if(plotColorLegend == TRUE){
        png(filename=paste(out,"ColorLegend","png",sep="."),
        width=0.15*plot.height, height=plot.height)
        f <- colorRampPalette(mycols)
        nr.labels <- 4
        leg <- rep('', 256)
        leg[seq(0.05*256, 0.95*256, length.out=nr.labels)] <-
            formatC(untransf(seq(0.05*transf(max(d*sums)), 0.95*
            transf(max(d*sums)), length.out=nr.labels)), format='f', digits=2)
        par(mar = c(12, 14, 2, 0.5))
        plot(1, 1, type='n', bty='n', xaxt='n', yaxt='n', xlim=c(0,1),
        ylim=c(0,7), xaxs="i", yaxs="i", xlab='', ylab='')
        box(lwd = 6)
        color.legend(0, 0, 1, 7, legend=leg, rect.col=f(256), align="lt",
        gradient='y', cex=cex.axis)
        dev.off()
    }
    
    return(a)
}


#################################
# Function for plotting heatmap


.plot.motif.heatmap <- function(motifScanningScores, flankUp=NULL,
flankDown=NULL, cols, breaks, xTicks=NULL, xTicksAt=NULL, xLabel="",
yTicks=NULL, yTicksAt=NULL, yLabel="", cexAxis=8, plotScale=TRUE,
scaleLength=NULL, scaleWidth=15, addReferenceLine=TRUE){
    
    par(mar = c(12, 8.5, 2, 8.5))
    
    if(length(xTicks) == 0){
        xTicks <- c(-1*flankUp, -1*flankUp/2, 0, flankDown/2, flankDown)
        xTicksAt <- cumsum(c(0.5, flankUp/2, flankUp/2, flankDown/2-1,
            flankDown/2))
    }
    
    image(t(motifScanningScores[nrow(motifScanningScores):1,]), col=cols,
    breaks=breaks, xaxt="n", yaxt="n")
    
    if(length(xTicks) > 0){
        axis(1, at=xTicksAt/(flankUp+flankDown), labels=xTicks,
        cex.axis=cexAxis, padj=1, lwd=6, tcl=-1)
    }
    if(length(yTicks) > 0){
        axis(2, at=yTicksAt/nrow(motifScanningScores), labels=yTicks,
        cex.axis=cexAxis, las=1, lwd=6, tcl=-1)
    }
    box(lwd = 6)
    if(plotScale){
        if(length(scaleLength) == 0){
            scaleLength <- (flankUp + flankDown)/5
        }
        lines(c(0.015, 0.015+scaleLength/(flankUp + flankDown)),
        c(0.03,0.03), lwd=scaleWidth, col="gray90")
        text(x=0.03/2+scaleLength/(2*(flankUp + flankDown)), y=0.06,
        labels=paste(round(scaleLength), 'bp', sep=''), cex=cexAxis,
        adj=c(0.5,0), col="gray90", font=2)
    }
    if(addReferenceLine){
        abline(v=(flankUp+0.5)/(flankUp+flankDown), lty="dashed",
        col="gray90", lwd=6)
    }

}



#######################################
# Function of plotting average signal


.plot.windowed.average <- function(occurence.melted.list, nr.seq,
pattern.widths, flankUp = NULL, flankDown = NULL, smoothingWindow = 3,
color = rainbow(length(occurence.melted.list)), xLabel =
"Distance to reference point (bp)", yLabel = "Relative frequency", cexAxis = 2,
addReferenceLine = TRUE, plotLegend = TRUE, cexLegend = 2, add = FALSE, ...){
    
    message("\nPlotting average signal...\n")
    patterns.avg.signal<-lapply(c(1:length(occurence.melted.list)),
    function(i) {
        x <- occurence.melted.list[[i]]
        a.s <- table(x$position)/nr.seq
        avg.signal <- rep(0, times =
        flankUp+flankDown-pattern.widths[i]+1)
        names(avg.signal) <- c(1:length(avg.signal))
        avg.signal[names(a.s)] <- a.s
        return(avg.signal)
    })
    
    starts <- lapply(patterns.avg.signal, function(x) {
        seq(1, length(x), by = smoothingWindow)
    })
    ends <- lapply(starts, function(x) {x + smoothingWindow - 1})
    ends <- lapply(1:length(ends), function(x) {
        ends[[x]][length(ends[[x]])] <- min(ends[[x]][length(ends[[x]])],
        length(patterns.avg.signal[[x]])); return(ends[[x]])
    })
    
    patterns.avg.signal.windowed <- lapply(c(1:length(patterns.avg.signal)),
    function(x){
        a.s <- sapply(seq(1:length(starts[[x]])), function(y) {
            mean(patterns.avg.signal[[x]][starts[[x]][y]:ends[[x]][y]])})
        x.coor <- (starts[[x]]+ends[[x]])/2 - flankUp - 1
        return(list(x.coor, a.s))
    })
    
    if(!(add)){
        plot(1, 1, xlim = c(-flankUp, flankDown), ylim = c(0,
        1.05*max(unlist(lapply(patterns.avg.signal.windowed, function(x) {
            max(x[[2]])})))), type = "n", xlab = xLabel, ylab = yLabel,
        cex.axis = cexAxis, cex.lab = cexAxis, ...)
    }
    
    a.s <- lapply(c(1:length(patterns.avg.signal.windowed)), function(i){
        lines(x = patterns.avg.signal.windowed[[i]][[1]],
        y = patterns.avg.signal.windowed[[i]][[2]], type = "l",
        col = color[i], ...)
    })
    
    if(plotLegend){
        legend("top", legend = names(pattern.widths), bty = "n", horiz = TRUE,
        lwd = 1, col = color, cex = cexLegend)
    }
    if(addReferenceLine){
        abline(v = 0, lty = "dashed")
    }


}

setGeneric(
name="plotPatternDensityMap",
def=function(regionsSeq, patterns, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, nBin = NULL, bandWidth = NULL,
    color = "blue", transf = NULL, xTicks = NULL, xTicksAt = NULL, xLabel = "",
    yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8, plotScale = TRUE,
    scaleLength = NULL, scaleWidth = 15, addPatternLabel = TRUE, cexLabel = 8,
    labelCol = "black", addReferenceLine = TRUE, plotColorLegend = TRUE,
    outFile = "PatternDensityMap", plotWidth = 2000, plotHeight = 2000,
    useMulticore = FALSE, nrCores = NULL){
        standardGeneric("plotPatternDensityMap")
    }
)

setMethod("plotPatternDensityMap",
signature(regionsSeq = "DNAStringSet"),
function(regionsSeq, patterns, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, nBin = NULL, bandWidth = NULL,
    color = "blue", transf = NULL, xTicks = NULL, xTicksAt = NULL, xLabel = "",
    yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8, plotScale = TRUE,
    scaleLength = NULL, scaleWidth = 15, addPatternLabel = TRUE, cexLabel = 8,
    labelCol = "black", addReferenceLine = TRUE, plotColorLegend = TRUE,
    outFile = "PatternDensityMap", plotWidth = 2000, plotHeight = 2000,
    useMulticore = FALSE, nrCores = NULL){
        
        pt <- .Platform$OS.type
        if(useMulticore == TRUE){
            if(pt == "unix"){
                if("parallel" %in% rownames(installed.packages()) == FALSE){
                    stop("Cannot use multicore because package 'parallel' 
                    is not installed!")
                }else{
                    library(parallel)
                    if(is.null(nrCores)){
                        nrCores <- detectCores()
                    }
                }
            }else{
                useMulticore <- FALSE
                warning("Multicore is not supported on non-Unix platforms! 
                Setting useMulticore=FALSE")
            }
        }
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the 
            same length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }
        if(length(patterns) == 0){
            stop("At least one pattern needs to be specified!")
        }
        
        if(length(flankUp) == 0){
            flankUp <- round(width(regionsSeq)[1]/2)
        }
        if(length(flankDown) == 0){
            flankDown <- width(regionsSeq)[1] - flankUp
        }
        if(!(color %in% c("green","cyan","blue","purple","pink","red","orange",
        "brown","gray"))){
            stop("Specified color scale not supported! Please choose one of the 
following color scales: 'green','cyan','blue','purple','pink','red','orange',
'brown','gray', and refer to the vignette for their appearance.")
        }
        
        message("\nGetting oligonucleotide occurrence matrix...")
        patterns.occurence.melted.list <- getPatternOccurrenceList(regionsSeq =
        regionsSeq, patterns = patterns, seqOrder = seqOrder,
        useMulticore = useMulticore, nrCores = nrCores)
        
        a <- .pattern.smoothscatter(melted = patterns.occurence.melted.list,
        orig = regionsSeq, patterns = patterns, flankUp = flankUp,
        flankDown = flankDown, bw = bandWidth, nbin = nBin, color = color,
        transf = transf, xTicks = xTicks, xTicksAt = xTicksAt, xLabel = xLabel,
        yTicks = yTicks, yTicksAt = yTicksAt, yLabel = yLabel,
        cex.axis = cexAxis, plot.scale = plotScale, scale.length = scaleLength,
        scale.width = scaleWidth, add.label = addPatternLabel,
        cex.label = cexLabel, label.col = labelCol,
        addReferenceLine = addReferenceLine, plotColorLegend = plotColorLegend,
        out = outFile, plot.width = plotWidth, plot.height = plotHeight,
        useMulticore = useMulticore, nrCores = nrCores)
    
    }
)


setGeneric(
name="plotPatternOccurrenceAverage",
def=function(regionsSeq, patterns, flankUp = NULL, flankDown = NULL,
smoothingWindow = 1, color = rainbow(length(patterns)),
xLabel = "Distance to reference point (bp)", yLabel = "Relative frequency",
cexAxis = 1, addReferenceLine = TRUE, plotLegend = TRUE,
cexLegend = 1, useMulticore = FALSE, nrCores = NULL, add = FALSE, ...){
    standardGeneric("plotPatternOccurrenceAverage")
}
)

setMethod("plotPatternOccurrenceAverage",
signature(regionsSeq = "DNAStringSet"),
function(regionsSeq, patterns, flankUp = NULL, flankDown = NULL,
    smoothingWindow = 1, color = rainbow(length(patterns)),
    xLabel = "Distance to reference point (bp)", yLabel = "Relative frequency",
    cexAxis = 1, addReferenceLine = TRUE, plotLegend = TRUE,
    cexLegend = 1, useMulticore = FALSE, nrCores = NULL, add = FALSE, ...){
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the
            same length!")
        }
        if(length(patterns) == 0){
            stop("At least one pattern needs to be specified!")
        }
        
        if(length(flankUp) == 0){
            flankUp <- round(width(regionsSeq)[1]/2)
        }
        if(length(flankDown) == 0){
            flankDown <- width(regionsSeq)[1] - flankUp
        }
        
        message("\nGetting oligonucleotide occurrence matrix...")
        patterns.occurence.melted.list <- getPatternOccurrenceList(regionsSeq =
        regionsSeq, patterns = patterns, seqOrder = c(1:length(regionsSeq)),
        useMulticore = useMulticore, nrCores = nrCores)
        pattern.widths <- width(patterns)
        names(pattern.widths) <- patterns
        
        .plot.windowed.average(occurence.melted.list =
        patterns.occurence.melted.list, nr.seq = length(regionsSeq),
        pattern.widths = pattern.widths, flankUp = flankUp, flankDown =
        flankDown, smoothingWindow = smoothingWindow, color = color, xLabel =
        xLabel, yLabel = yLabel, cexAxis = cexAxis, addReferenceLine =
        addReferenceLine, plotLegend = plotLegend, cexLegend = cexLegend,
        add = add, ...)

    }
)


setGeneric(
name="plotMotifDensityMap",
def=function(regionsSeq, motifPWM, minScore = "80%",
    seqOrder = c(1:length(regionsSeq)), flankUp = NULL, flankDown = NULL,
    nBin = NULL, bandWidth = NULL, color = "blue", transf = NULL, xTicks = NULL,
    xTicksAt = NULL, xLabel = "", yTicks = NULL, yTicksAt = NULL, yLabel = "",
    cexAxis = 8, plotScale = TRUE, scaleLength = NULL, scaleWidth = 15,
    addReferenceLine = TRUE, plotColorLegend = TRUE, outFile = "DensityMap",
    plotWidth = 2000, plotHeight = 2000){
        standardGeneric("plotMotifDensityMap")
    }
)

setMethod("plotMotifDensityMap",
signature(regionsSeq = "DNAStringSet", motifPWM = "matrix"),
function(regionsSeq, motifPWM, minScore = "80%",
    seqOrder = c(1:length(regionsSeq)), flankUp = NULL, flankDown = NULL,
    nBin = NULL, bandWidth = NULL, color = "blue", transf = NULL, xTicks = NULL,
    xTicksAt = NULL, xLabel = "", yTicks = NULL, yTicksAt = NULL, yLabel = "",
    cexAxis = 8, plotScale = TRUE, scaleLength = NULL, scaleWidth = 15,
    addReferenceLine = TRUE, plotColorLegend = TRUE, outFile = "DensityMap",
    plotWidth = 2000, plotHeight = 2000){
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the 
            same length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }
        
        if(length(flankUp) == 0){
            flankUp <- round(width(regionsSeq)[1]/2)
        }
        if(length(flankDown) == 0){
            flankDown <- width(regionsSeq)[1] - flankUp
        }
        
        if(!(color %in% c("green","cyan","blue","purple","pink","red","orange",
        "brown","gray"))){
            stop("Specified color scale not supported! Please choose one of the 
following color scales: 'green','cyan','blue','purple','pink','red','orange','
brown','gray', and refer to the vignette for their appearance.")
        }

        message("\nGetting motif occurrence matrix...")
        motif.occurence.melted <- motifScanHits(regionsSeq = regionsSeq,
        motifPWM = motifPWM, minScore = minScore, seqOrder = seqOrder)
        
        if(nrow(motif.occurence.melted) == 0){
            cat("\nNo motif hits above specified score threshold found!\n
Try lowering the score threshold.\nExiting without making a density plot.\n\n")
        }else{
        
        motif.occurence.melted.list <- list(motif = motif.occurence.melted)
        
        a <- .pattern.smoothscatter(melted = motif.occurence.melted.list,
        orig = regionsSeq, patterns = "motif", flankUp = flankUp,
        flankDown = flankDown, bw = bandWidth, nbin = nBin, color = color,
        transf = transf, xTicks = xTicks, xTicksAt = xTicksAt, xLabel = xLabel,
        yTicks=yTicks, yTicksAt=yTicksAt, yLabel = yLabel, cex.axis = cexAxis,
        plot.scale = plotScale, scale.length = scaleLength,
        scale.width = scaleWidth, add.label = FALSE, cex.label = cexAxis,
        addReferenceLine = addReferenceLine, plotColorLegend = plotColorLegend,
        out = outFile, plot.width = plotWidth, plot.height = plotHeight)
        }
    }
)


setGeneric(
name="plotMotifOccurrenceAverage",
def=function(regionsSeq, motifPWM, minScore = "80%", flankUp = NULL,
flankDown = NULL, smoothingWindow = 1, color = "black",
xLabel = "Distance to reference point (bp)", yLabel = "Relative frequency",
cexAxis = 1, addReferenceLine = TRUE, plotLegend = FALSE, cexLegend = 1,
add = FALSE, ...){
    standardGeneric("plotMotifOccurrenceAverage")
}
)

setMethod("plotMotifOccurrenceAverage",
signature(regionsSeq = "DNAStringSet", motifPWM = "matrix"),
function(regionsSeq, motifPWM, minScore = "80%", flankUp = NULL,
flankDown = NULL, smoothingWindow = 1, color = "black",
xLabel = "Distance to reference point (bp)", yLabel = "Relative frequency",
cexAxis = 1, addReferenceLine = TRUE, plotLegend = FALSE, cexLegend = 1,
add = FALSE, ...){
    
    if(!(length(unique(width(regionsSeq))) == 1)){
        stop("All sequences in the input DNAStringSet must have the
        same length!")
    }
    if(length(flankUp) == 0){
        flankUp <- round(width(regionsSeq)[1]/2)
    }
    if(length(flankDown) == 0){
        flankDown <- width(regionsSeq)[1] - flankUp
    }
    
    message("\nGetting motif occurrence matrix...")
    motif.occurence.melted <- motifScanHits(regionsSeq = regionsSeq, motifPWM =
        motifPWM, minScore = minScore, seqOrder = c(1:length(regionsSeq)))
    motif.occurence.melted.list <- list(motif = motif.occurence.melted)
    pattern.widths <- ncol(motifPWM)
    names(pattern.widths) <- "motif"
    
    .plot.windowed.average(occurence.melted.list = motif.occurence.melted.list,
    nr.seq = length(regionsSeq), pattern.widths = pattern.widths, flankUp =
    flankUp, flankDown = flankDown, smoothingWindow = smoothingWindow, color =
    color, xLabel = xLabel, yLabel = yLabel, cexAxis = cexAxis,
    addReferenceLine = addReferenceLine, plotLegend = plotLegend, cexLegend =
    cexLegend, add = add, ...)
    
}
)


setGeneric(
name="plotMotifScanScores",
def=function(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, xTicks = NULL, xTicksAt = NULL,
    xLabel = "", yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8,
    plotScale = TRUE, scaleLength = NULL, scaleWidth = 15,
    addReferenceLine = TRUE, plotColorLegend = TRUE,
    outFile = "MotifScanningScores.png", plotWidth = 2000, plotHeight = 2000){
        standardGeneric("plotMotifScanScores")
    }
)

setMethod("plotMotifScanScores",
signature(regionsSeq = "DNAStringSet", motifPWM = "matrix"),
function(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, xTicks = NULL, xTicksAt = NULL,
    xLabel = "", yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8,
    plotScale = TRUE, scaleLength = NULL, scaleWidth = 15,
    addReferenceLine = TRUE, plotColorLegend = TRUE,
    outFile = "MotifScanningScores.png", plotWidth = 2000, plotHeight = 2000){
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the 
            same length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }
        
        if(length(flankUp) == 0){
            flankUp <- round(width(regionsSeq)[1]/2)
        }
        if(length(flankDown) == 0){
            flankDown <- width(regionsSeq)[1] - flankUp
        }
        
        message("\nGetting motif scanning scores...")
        motif.scanning.scores <- motifScanScores(regionsSeq = regionsSeq,
        motifPWM = motifPWM, seqOrder = seqOrder)
        
        message("\nPlotting heatmap...")
        png(filename=outFile, width = plotWidth, height = plotHeight)
        
        breaks <- c(0,60,seq(62,100,2))
        colsFun <- colorRampPalette(c("darkblue", "blue", "cyan", "yellow",
        "red2"))
        cols <- colsFun(length(breaks) - 1)
        
        if(plotColorLegend){
            layout(mat = matrix(c(2,1), nrow = 1), widths = c(0.88, 0.12))
            par(mar = c(12, 0, 2, 12))
            plot(c(0,0), type = "n", xaxt = "n", yaxt = "n", xlab = "",
            ylab = "", xlim = c(0,1), ylim = c(0,1), xaxs = "i", yaxs = "i")
            box(lwd = 6)
            color.legend(xl=0, yb=0, xr=1, yt=1,
            legend=c("0 %", seq(20,100,20)), rect.col=rep(cols,
            times=round(diff(breaks)/min(diff(breaks)))),
            align="rb", gradient="y", cex=cexAxis)
        }
        
        .plot.motif.heatmap(motifScanningScores = motif.scanning.scores,
        flankUp = flankUp, flankDown = flankDown, cols = cols, breaks = breaks,
        xTicks = xTicks, xTicksAt = xTicksAt, xLabel = xLabel, yTicks = yTicks,
        yTicksAt = yTicksAt, yLabel = yLabel, cexAxis = cexAxis,
        plotScale = plotScale, scaleLength = scaleLength,
        scaleWidth = scaleWidth, addReferenceLine = addReferenceLine)
        
        dev.off()
    
    }
)

.scan.sequence.with.pwm <- function(pwm, seq, minScore){
    
    nc <- nchar(minScore)
    if (substr(minScore, nc, nc) == "%"){
        perc.threshold <- substr(minScore, 1L, nc-1L)
        min.score <- minScore(pwm)
        max.score <- maxScore(pwm)
        score.threshold = min.score + as.double(perc.threshold)/100 *
            (max.score-min.score)
    }else{
        score.threshold <- minScore
    }

    # make all PWM scores positive to avoid matching the Ns which are assigned score 0
    pwm.corr <- pwm + abs(min(pwm))
    score.threshold <- score.threshold + ncol(pwm) * abs(min(pwm))

    pwm.match <- matchPWM(pwm = pwm.corr, subject = seq, min.score = score.threshold)
    return(start(pwm.match))

}

.get.scanning.score <- function(pwm, seq){

# make all PWM scores positive to avoid matching the Ns which are assigned score 0
    pwm.corr <- pwm + abs(min(pwm))

    pwm.scores <- PWMscoreStartingAt(pwm = pwm.corr, subject = seq,
    starting.at = c(1:(length(seq) - ncol(pwm) + 1)))

    pwm.scores <- pwm.scores - ncol(pwm) * abs(min(pwm))
    return(pwm.scores)

}

test_.scan.sequence.with.pwm <- function(){
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEquals(seqPattern:::.scan.sequence.with.pwm(pwm = TBPpwm,
    seq = zebrafishPromoters[[1]], minScore = "90%"), c(51, 53, 55, 204, 344, 905))
}

test_.get.scanning.score <- function(){
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEqualsNumeric(seqPattern:::.get.scanning.score(pwm = TBPpwm,
    seq=zebrafishPromoters[[1]])[c(1:5)],
    c(-18.805607170,-23.526148870,-18.062235212,-23.998492469,-25.615083293),
    tolerance = 10^-9)
}

setGeneric(
name="motifScanHits",
def=function(regionsSeq, motifPWM, minScore = "80%",
    seqOrder = c(1:length(regionsSeq))){
        standardGeneric("motifScanHits")
    }
)

setMethod("motifScanHits",
signature(regionsSeq = "DNAStringSet", motifPWM = "matrix"),
function(regionsSeq, motifPWM, minScore = "80%",
    seqOrder = c(1:length(regionsSeq))){
    
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the same 
            length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }

        pwm.match <- lapply(regionsSeq[seqOrder], function(x){
            .scan.sequence.with.pwm(pwm = motifPWM, seq = x, minScore=minScore)
        })
        
        data.frame(sequence = rep(c(1:length(pwm.match)),
        times = unlist(lapply(pwm.match, length))),
        position = unlist(pwm.match), value = rep(1, times = length(unlist(pwm.match))))
    
    }
)


setGeneric(
name="motifScanScores",
def=function(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
    asPercentage = TRUE){
    standardGeneric("motifScanScores")
    }
)

setMethod("motifScanScores",
signature(regionsSeq = "DNAStringSet", motifPWM = "matrix"),
function(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
    asPercentage = TRUE){
        
        if(!(length(unique(width(regionsSeq))) == 1)){
            stop("All sequences in the input DNAStringSet must have the same 
            length!")
        }
        if(!(length(seqOrder) == length(regionsSeq))){
            stop("The number of elements in 'seqOrder' must match the number 
            of input sequences in 'regionsSeq'!")
        }
        
        regionsSeq <- regionsSeq[seqOrder]
        scanning.score.list <- lapply(regionsSeq, function(x){
            PWMscoreStartingAt(pwm = motifPWM, subject = x, starting.at =
            c(1:(length(regionsSeq[[1]]) - ncol(motifPWM) + 1)))
        })
        scanning.score.matrix <- do.call(rbind, scanning.score.list)
        scanning.score.matrix[scanning.score.matrix < minScore(motifPWM)] <- minScore(motifPWM)

        if(asPercentage){
            max.score <- maxScore(motifPWM)
            min.score <- minScore(motifPWM)
            return((scanning.score.matrix-min.score)/(max.score-min.score)*100)
        }else{
            return(scanning.score.matrix)
        }
    
    }
)

test_motifScanHits <- function(){
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEquals(motifScanHits(regionsSeq = zebrafishPromoters[1:5],
    motifPWM = TBPpwm, minScore = "95%", seqOrder = c(1,4,2,3,5)),
    data.frame(sequence = as.integer(c(1,1,1,2,4,4)),
    position = as.integer(c(51,53,55,271,761,815)), value = rep(1,6)))
}

test_motifScanScores <- function(){
    library(Biostrings)
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEqualsNumeric(as.vector(motifScanScores(regionsSeq =
    subseq(zebrafishPromoters[1:5], start = 1, end = 10),
    motifPWM = TBPpwm, seqOrder = c(1,4,2,3,5))),
    c(47.16491,43.42071,50.86560,51.06228,53.98393,39.21015,56.48875,
    66.81754,73.50455,31.59049,48.41759,47.59350,49.04233,47.88635,65.04803),
    tolerance = 10^-5)
}

test_getPatternOccurrenceList <- function(){
    data(zebrafishPromoters)
    data(TBPpwm)
    checkEquals(getPatternOccurrenceList(regionsSeq = zebrafishPromoters[1:5],
    patterns = c("TCTGWA", "ASWDGTW"), seqOrder = c(1,4,2,3,5)),
    list(TCTGWA = data.frame(sequence = as.integer(c(2,4,4)),
    position = as.integer(c(61,120,930)), value = rep(1,3)),
    ASWDGTW = data.frame(sequence = as.integer(c(1,1,1,2,3,3,3,5)),
    position = as.integer(c(226,685,796,897,73,364,974,542)), value=rep(1,8))))
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\VignetteIndexEntry{seqPattern}
%\VignetteKeywords{seqPattern}
%\VignettePackage{seqPattern}

\documentclass[12pt]{article}

<<style-Sweave, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\usepackage{amsmath}
\usepackage{hyperref}
\usepackage{float}

\textwidth=6.2in
\textheight=8.5in
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}

\bioctitle[seqPattern]{seqPattern: an R package for visualisation of 
oligonucleotide sequence patterns and motif occurrences}

\author{Vanja Haberle \footnote{vanja.haberle@gmail.com}}
\date{May 8, 2015}

\begin{document}
<<setup, echo=FALSE>>=
options(width = 80)
olocale=Sys.setlocale(locale="C")
@ 
\maketitle
\tableofcontents


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
This document briefly describes how to use the package \Rpackage{seqPattern}. 
\Rpackage{seqPattern} is a Bioconductor-compliant R package designed to 
visualise sequence patterns across a large set of sequences (\emph{e.g.} 
promoters, enhancers, ChIPseq peaks, \emph{etc.}) centred at a common reference 
position (\emph{e.g.} TSS, peak position) and ordered by some feature. The 
visualisations includes plotting the density of occurrences of di-, tri-, and
in general any oligo-nucleotides, consensus sequences specified using IUPAC
nucleotide ambiguity codes and motifs specified by a position weight matrix 
(PWM). Such visualisations are useful in discovering sequence patterns 
positionally constrained with respect to the reference point and their 
correlation with the specified feature \cite{Haberle:2014}.
\newline
Here is a list of functionalities provided in this package:

\begin{itemize}
\item
Obtaining positions of occurrences of oligonucleotides or consensus sequences
in an ordered set of sequences centred at a common reference point in a
matrix-like representation.
\item
Visualising density of oligonucleotide or consensus sequence occurrences in an 
ordered set of sequences centred at a common reference point. Multiple 
oligonucleotides can be analysed simultaneously and their density plotted on
the same colour scale allowing visual comparison of enrichments/depletions of
various oligonucleotides.
\item
Visualising average oligonucleotide profile for a set of sequences centred at a 
common reference point.
\item
Obtaining positions of occurrences of motifs defined by a PWM in an ordered set 
of sequences centred at a common reference point in a matrix-like 
representation. A custom threshold can be applied to report only motif matches 
with score above specified percentage of the maximal PWM score. 
\item
Visualising density of motif occurrences in an ordered set of sequences centred 
at a common reference point. Only motif matches with score above specified 
percentage of the maximal PWM score are visualised.
\item
Visualising motif scanning scores for an ordered set of sequences centred at a 
common reference point in the form of a heatmap.
\item
Visualising average motif occurrence profile (motif specified by a PWM) for a 
set of sequences centred at a common reference point. 
\end{itemize}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Getting started}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
To load the \Rpackage{seqPattern} package into your R envirnoment type:
<<>>=
library(seqPattern)
@


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Example data}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
The package contains two data sets provided for illustrating the functionality 
of the package. 

\subsection{Zebrafish promoter sequences}
The first dataset is \Rcode{zebrafishPromoters} and can be loaded by typing:
<<>>=
data(zebrafishPromoters)
zebrafishPromoters
head(zebrafishPromoters@elementMetadata)
@

It is a \Rcode{DNAStringSet} object that contains sequence of 1000 randomly 
selected promoters active in zebrafish (\emph{Danio rerio}) embryos at 24 hours 
past fertilisation (hpf). The data is taken from Nepal \emph{et al.} 
\cite{Nepal:2013}, and represents regions flanking 400 bp upstream and 600 bp 
downstream of the dominant TSS detected by Cap analysis of gene expression 
(CAGE). In addition to genomic sequence, the object contains metadata providing 
CAGE tag per million values and interquantile width for each promoter. This 
small example dataset is intended to be used as input for running examples from 
\Rpackage{seqPattern} package help pages. 

\subsection{Zebrafish promoter coordinates and associated features}
The second dataset is \Rcode{zebrafishPromoters24h}, which can be loaded by 
typing:
<<>>=
data(zebrafishPromoters24h)
head(zebrafishPromoters24h)
@

This is a \Rcode{data.frame} object that contains genomic coordinates of all 
(10785 in total) promoters active in zebrafish \emph{Danio rerio} embryos at 24 
hpf \cite{Nepal:2013}. For each promoter additional information is provided, 
including position of the dominant (most frequently used) TSS position, number 
of CAGE tags per million supporting that promoter and the interquantile width
of the promoter (width of the central region containing >= 80\% of the CAGE
tags). All examples in this vignette use this dataset to demonstrate how to use
various functions provided in the package and illustrate the resulting
visualisation.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Visualising oligonucleotide and consensus sequence densities}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

In this part of the tutorial we will be using data from zebrafish (\emph{Danio 
rerio}) that was mapped to the danRer7 assembly of the genome. 
Therefore, the corresponding genome package 
\Rpackage{BSgenome.Drerio.UCSC.danRer7} has to be installed and available to
load by typing:
<<>>=
library(BSgenome.Drerio.UCSC.danRer7)
@

\subsection{Preparing input sequences}
As input we will use a full set of zebrafish promoters active in 24 hpf embryos 
that were precisely mapped using CAGE \cite{Nepal:2013}. To load the zebrafish 
promoters data type:
<<>>=
data(zebrafishPromoters24h)
nrow(zebrafishPromoters24h)
head(zebrafishPromoters24h)
@

The loaded \Rcode{data.frame} contains genomic coordinates, position of the 
dominant (most frequently used) TSS position, number of CAGE tags per million 
and the interquantile width (width of the central region containing >= 80\% of 
the CAGE tags) for each promoter.

Next, we need to obtain the genomic sequence of the promoter region for which 
the oligonucleotide density will be visualised, for instance the region
flanking 400 bp upstream and 800 bp downstream of the dominant TSS. Thus, in
this case the dominant TSS will be the reference point to which all promoter
sequences will be aligned. We also want to keep the information about promoter
interquantile width, since this feature will be used to order the promoters in 
the density map.
<<>>=
# create GRanges of dominant TSS position with associated metadata
zebrafishPromotersTSS <- GRanges(seqnames = zebrafishPromoters24h$chr,
            ranges = IRanges(start = zebrafishPromoters24h$dominantTSS, 
            end = zebrafishPromoters24h$dominantTSS), 
            strand = zebrafishPromoters24h$strand, 
            interquantileWidth = zebrafishPromoters24h$interquantileWidth, 
            seqlengths = seqlengths(Drerio))
# get regions flanking TSS - 400 bp upstream and 800 bp downstream
zebrafishPromotersTSSflank <- promoters(zebrafishPromotersTSS, upstream = 400, 
                                        downstream = 800)
# obtain genomic sequence of flanking regions
zebrafishPromotersTSSflankSeq <- getSeq(Drerio, zebrafishPromotersTSSflank)
@

Note that all regions need to have the same width for plotting, and in cases 
when flanking regions fall outside of chromosome boundaries they need to be 
removed prior to plotting the oligonucleotide density map. (For instance, use 
the \Rcode{trim} function from the \emph{GenomicRanges} package to restrict 
regions within the boundaries of chromosomes and then remove ranges shorter than 
expected width.)

\subsection{Plotting dinucleotide density maps}
Once a \Rcode{DNAStringSet} object is obtained, it can be used to plot the 
density of oligonucleotides of interest. In the following example, we will plot 
the density of AA, TA, CG and GC dinucleotides for the obtained set of
sequences sorted by the promoter interquantile width (Figure~
\ref{fig:OligonucleotideDensities}):
<<eval=FALSE>>=
plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            patterns = c("AA", "TA", "CG", "GC"), 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
            flankUp = 400, flankDown = 800, color = "blue")
@

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=123mm]{images/OligonucleotideDensity.jpg}
\caption{Density of AA, TA, CG and GC dinucleotides in regions flanking
dominant TSS in zebrafish 24h embryo promoters ordered by promoter width}
\label{fig:OligonucleotideDensities}
\end{figure}

The information about the number of base pairs upstream and downstream of the 
reference point (\Rcode{flankUp} and \Rcode{flankDown}) needs to be specified
in cases where these are asymmetric. If not specified, it is assumed that the
reference point is located in the middle of the provided sequences (\emph{i.e.} 
half of the total length in bp). There is also a number of graphical parameters 
that can be adjusted, such as color palette, width and hight of the plot in
pixels, axis labels, scale bars, \emph{etc.}, and they are explained in detail
in the help page of the \Rcode{plotPatternDensityMap} function. Default colour
palette is in shades of blue going from white through lightblue to darkblue.
Alternative colour palettes are available as shown in 
Figure~\ref{fig:ColorPalettes}, and can be specified by setting the \Rcode{color} 
parameter to the name of the corresponding palette. 

\begin{figure}[H]
\centering
\includegraphics[width=100mm,height=67mm]{images/ColorPalettes.pdf}
\caption{Available colour palettes for plotting oligonucleotide density maps. 
Name of each palette is indicated and can be used as \Rcode{color} parameter 
within the \Rcode{plotPatternDensityMap} function to specify the corresponding 
colour palette for plotting.}
\label{fig:ColorPalettes}
\end{figure}

The two main parameters that define how the density of
the pattern will be calculated and plotted are \Rcode{nBin} and
\Rcode{bandWidth}. The \Rcode{nBin} parameter specifies the number of bins in
which the plot will be divided across x (horizontal, corresponding to the
sequence length) and y axes (vertical, corresponding to the number of
sequences). The default value is to calculate the density at each position in 
every sequence, \emph{i.e.} the number of bins in the horizontal direction is 
set to the sequence length and in the vertical direction to the total number of 
sequences. The \Rcode{bandWidth} parameter specifies the standard deviation of 
the bivariate Gaussian kernel along the x (\emph{i.e.} number of nucleotides) 
and y (\emph{i.e.} number of sequences) axis that is used to compute the
density for each bin. The schematic in Figure~\ref{fig:DensitySchematics}
illustrates how the density of three different dinucleotides is calculated for
a set of 10 sequences each 10 bp long, using a 2D Gaussian kernel with standard
deviation of 5 in both directions. The calculations for larger sets of
sequences and for any specified sequence pattern are done analogously.
Note that \Rpackage{seqPattern} package supports parallel processing using 
multiple cores on Unix-like platforms, which significantly reduces the 
computational time when visualising density of multiple patterns. For instance, 
the above example that calculates the density of 4 dinucleotides can be run on
4 cores by setting the \Rcode{useMulticore} and \Rcode{nrCores} parameters:

<<eval=FALSE>>=
plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            patterns = c("AA", "TA", "CG", "GC"), 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
            flankUp = 400, flankDown = 800, useMulticore = TRUE, nrCores = 4)
@

Calling the \Rcode{plotPatternDensityMap} function will create one .png file
per specified pattern in the working directory. The resulting dinucleotide
density plots reveal complex pattern of dinucleotide enrichments/depletions in
zebrafish promoters (Figure~\ref{fig:OligonucleotideDensities}). The density of
all dinucleotides is plotted on the same colour scale, which allows direct
comparison. For instance, it is clear that CG dinucleotides are generally 
less abundant than other dinucleotides. The region immediately upstream and 
downstream of TSS is enriched for CG and GC dinucleotides and depleted for TA 
and AA dinucleotides. Within this region, there is narrow band of TA and AA 
enrichment {\raise.17ex\hbox{$\scriptstyle\mathtt{\sim}$}}30 bp upstream of the 
TSS visible only in sharp promoters (top). Region downstream of TSS is 
characterised by alternating bands of enrichments and depletions visible for
all four dinucleotides and this pattern is more prominent in broad promoters
(bottom).Thus, visualising sequence in such way reveals differences in 
underlying sequence composition and its relation to the reference point, as
well as how this changes with some associated feature.

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=170mm]{images/DensitySchematic.pdf}
\caption{Schematics illustrating steps in pattern density calculation and 
visualisation. Genomic sequences (of the same length) are sorted and aligned 
into a matrix-like representation. Marking the presence of selected
dinucleotide by 1 and the absence by 0 creates an occurrence matrix. Next, a
weighted average is calculated at each position by placing a 2D Gaussian kernel
at that position and assigning weights to surrounding positions. An example of
calculating the value at position S4,P7 is shown. Surrounding positions are
coloured on the basis of the weights assigned to them by the Gaussian kernel
(bandwidth=5 in both dimensions, and covariance=0 between the two dimensions).
Averaged values are mapped to different shades of blue to visualise the
dinucleotide density.}
\label{fig:DensitySchematics}
\end{figure}

In addition to plotting density map of individual dinucleotides, a 
"metadinucleotide" can be specified using IUPAC nucleotide ambiguity codes. For 
instance, for the same set of promoter regions we can plot the density of all
WW and all SS dinucleotides in the same plot (Figure~
\ref{fig:MetaligonucleotideDensities}):
<<eval=FALSE>>=
plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            patterns = c("WW", "SS"), 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
            flankUp = 400, flankDown = 800, color = "cyan", labelCol = "white")
@

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=63mm]{images/MetaoligonucleotideDensity.jpg}
\caption{Density of WW and SS dinucleotides in regions flanking dominant TSS in 
zebrafish 24h embryo promoters ordered by promoter width}
\label{fig:MetaligonucleotideDensities}
\end{figure}


\subsection{Plotting average oligonucleotide profiles}
In addition to plotting oligonucleotide density maps, which show how a 
particular sequence pattern around referent point changes with some associated 
feature, the package also provides function for plotting average oligonucleotide 
profiles. For instance, we can visualise the average profile of WW and SS 
metadinucleotides for two groups of promoters separated by width (\emph{i.e.} 
sharp and broad promoters; \ref{fig:OligonucleotideAverage}) as follows:
<<eval=FALSE>>=
# make index of sharp and broad promoters
sIdx <- zebrafishPromotersTSSflank$interquantileWidth <= 9
bIdx <- zebrafishPromotersTSSflank$interquantileWidth > 9
# plot average dinucleotide profile for sharp promoters
par(mfrow = c(1,2), mar = c(4.5,4,1,1))
plotPatternOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[sIdx], 
            patterns = c("WW", "SS"), flankUp = 400, flankDown = 800, 
            smoothingWindow = 3, color = c("red3", "blue3"), cex.axis = 0.9)
# plot average dinucleotide profile for broad promoters
plotPatternOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[bIdx], 
            patterns = c("WW", "SS"), flankUp = 400, flankDown = 800, 
            smoothingWindow = 3, color = c("red3", "blue3"), cex.axis = 0.9)
@

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=66mm]{images/OligonucleotideAverage.pdf}
\caption{Average profile of WW and SS dinucleotides in region flanking dominant 
TSS for sharp promoters (width < 10 bp; left) and broad promoters (width >= 10 
bp)}
\label{fig:OligonucleotideAverage}
\end{figure}


\subsection{Plotting consensus sequence density map}
Analogously to plotting dinucleotide density as described above, the 
\Rcode{plotPatternDensityMap} function can be used to visualise the density of 
longer consensus sequences specified using IUPAC nucleotide ambiguity codes. For 
instance, one can use a consensus sequence of a transcription factor binding 
site to visualise density of these sites with respect to some reference point. 
Here we show an example of plotting density of the TATA-box consensus sequence 
(TATAWAWR) and GC-box / Sp1 binding site consensus sequence (RGGMGGR) across 
zebrafish promoters for sense and antisense strand separately. (Note that the 
easiest way to visualise occurrence of a consensus sequence in the antisense 
strand is to use the reverse complement of the consensus sequence, which in our 
case corresponds to YWTWTATA and YCCKCCY, for TATA-box and GC-box respectively.)
<<>>=
# get regions flanking dominant TSS - 200bp upstream and downstream
zebrafishPromotersTSSflank <- promoters(zebrafishPromotersTSS, upstream = 200, 
                                        downstream = 200)
# obtain genomic sequence of the flanking regions
zebrafishPromotersTSSflankSeq <- getSeq(Drerio, zebrafishPromotersTSSflank)
@
<<eval=FALSE>>=
# plot density of TATA-box consensus sequence in pink
plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            patterns = c("TATAWAWR", "YWTWTATA"), 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
            flankUp = 200, flankDown = 200, nBin = c(400, 10000), 
            bandWidth = c(1,6), color = "pink", addPatternLabel = FALSE)
 # plot density of GC-box consensus sequence in purple
plotPatternDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            patterns = c("RGGMGGR", "YCCKCCY"), 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth), 
            flankUp = 200, flankDown = 200, nBin = c(400, 10000), 
            bandWidth = c(1,6), color = "purple", addPatternLabel = FALSE)
@

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=123mm]{images/ConsensusDensity.jpg}
\caption{Density of the TATA-box consensus sequence (TATAWAWR; top) and GC-box 
(Sp1 binding site) consensus sequence (RGGMGGR; bottom) in regions flanking 
dominant TSS in zebrafish 24h embryo promoters ordered by promoter width. 
Matches in the sense strand are shown on the left and in the antisense strand on 
the right.}
\label{fig:ConsensusDensity}
\end{figure}

In the resulting density plot (Figure~\ref{fig:ConsensusDensity}) promoters are 
aligned to dominant TSS and sorted by promoter width. This reveals that the 
TATA-box consensus sequence is positioned very precisely at {\raise.17ex\hbox{$
\scriptstyle\mathtt{\sim}$}}30 bp upstream of the TSS mainly in the sense strand 
and that it is present only in very sharp promoters (top of the density plot), 
but not in the broad promoters (bottom of the density plot). In contrast, the 
GC-box (Sp1 binding site) consensus sequence is present in both strands and in 
both sharp and broad promoters roughly in the region 40-80 bp upstream of the 
TSS, but it seems more focused in sharp promoters.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Visualising motif occurrences}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Plotting density of motif occurrences}
In addition to using consensus sequence, the binding motif of a certain 
transcription factor can be described by a position-weight matrix (PWM), which 
gives the probability of occurrence of each of the four nucleotides at a given 
position in the motif. More specifically, the values in the PWM are derived
from the position-specific frequency matrix and represent log-ratio between
nucleotide probabilities derived from observed frequency and expected
background probability for the corresponding nucleotide \cite{Wasserman:2004}.
An example of a PWM describing the binding motif for the TATA-box binding
transcription factor (TBP) is provided in the package and can be loaded:
<<>>=
data(TBPpwm)
TBPpwm
@

The \Rcode{plotMotifDensityMap} function takes a PWM as an input, scans all sequences
for the occurrence of the motif above the specified match threshold
(\emph{e.g.} 90\%) and visualises the density of the motif with respect to the reference point
(Figure~\ref{fig:MotifDensity}, left):

<<eval=FALSE>>=
plotMotifDensityMap(regionsSeq = zebrafishPromotersTSSflankSeq, 
            motifPWM = TBPpwm, minScore = "90%", 
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
            flankUp = 200, flankDown = 200, color = "red")
@

\subsection{Plotting motif scanning scores}
On the other hand, using the \Rcode{plotMotifScanScores} function it is
possible to visualise the PWM scanning scores along entire sequences in a form
of a heatmap (Figure~\ref{fig:MotifDensity}, right):
<<eval=FALSE>>=
plotMotifScanScores(regionsSeq = zebrafishPromotersTSSflankSeq, 
            motifPWM = TBPpwm,
            seqOrder = order(zebrafishPromotersTSSflank$interquantileWidth),
            flankUp = 200, flankDown = 200)
@

\begin{figure}[H]
\centering
\includegraphics[width=140mm,height=63mm]{images/MotifDensity.jpg}
\caption{Density of TATA-box motif occurrence above 90\% of PWM score (left)
and heatmap of PWM scanning scores along all sequences (right) in regions
flanking dominant TSS in zebrafish 24h embryo promoters ordered by promoter
width}
\label{fig:MotifDensity}
\end{figure}

In addition to showing positioning and enrichment of strong motif occurrences 
with high match to the provided PWM, this form of visualisation can also reveal 
positional constraints for occurrences of motifs with varying strength. For 
instance weaker motifs might have different positional preference with respect 
to the reference point and might occur only in a subset of sequences
correlating with some feature, which will be visible when the sequences are
sorted according to that feature.

\subsection{Plotting average motif occurrence profile}
Analogously to plotting average oligonucleotide profiles described above, 
average occurrence profile of a motif specified by a PWM can be visualised using 
\Rcode{plotMotifOccurrenceAverage} function. The following code exemplifies how 
to visualise average occurrence of a TATA-box motif (above 90\% match to PWM) in 
previously defined subsets of sharp and broad promoters (Figure~\ref{fig:MotifAverage}):
<<eval=FALSE>>=
# make index of sharp and broad promoters
sIdx <- zebrafishPromotersTSSflank$interquantileWidth <= 9
bIdx <- zebrafishPromotersTSSflank$interquantileWidth > 9
# plot average motif occurrence profile for sharp promoters
plotMotifOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[sIdx], 
            motifPWM = TBPpwm, minScore = "90%", flankUp = 200, flankDown = 200, 
            smoothingWindow = 3, color = c("red3"), cex.axis = 0.9)
# add average motif occurrence profile for broad promoters to the existing plot
plotMotifOccurrenceAverage(regionsSeq = zebrafishPromotersTSSflankSeq[bIdx], 
            motifPWM = TBPpwm, minScore = "90%", flankUp = 200, flankDown = 200, 
            smoothingWindow = 3, color = c("blue3"), add = TRUE)
legend("topright", legend = c("sharp", "broad"), col = c("red3", "blue3"), 
bty = "n", lwd = 1)
@

\begin{figure}[H]
\centering
\includegraphics[width=70mm,height=66mm]{images/MotifAverage.pdf}
\caption{Average profile of TATA-box motif occurrence above 90\% of PWM score in 
regions flanking dominant TSS in sharp (red) and broad (blue) promoters}
\label{fig:MotifAverage}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Getting occurrence of sequence patterns and motifs without 
visualisation}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The above described functions find the occurrence of specified sequence
patterns or motifs in an ordered set of sequences, calculate their density and
visualise the result as a density map. The \Rpackage{seqPattern} package also
provides functions for finding only the occurrence of patterns or motifs
without calculating the density and visualising it in a plot. These are
\Rcode{getPatternOccurrenceList} and \Rcode{motifScanHits} for finding 
occurrence of patterns/consensus sequences and motifs specified by a PWM, 
respectively.
<<>>=
motifOccurrence <- motifScanHits(regionsSeq = 
            zebrafishPromotersTSSflankSeq[1:50], 
            motifPWM = TBPpwm, minScore = "90%", seqOrder = 
            order(zebrafishPromotersTSSflank$interquantileWidth[1:50]))
head(motifOccurrence)
@
The occurrences are returned as coordinates in a matrix-like representation as 
follows: Input sequences of the same length are sorted according to the index
in \Rcode{seqOrder} argument creating an \Rcode{n x m} matrix where \Rcode{n}
is the number of sequences and \Rcode{m} is the length of the sequence. For
each pattern match the coordinates within such matrix are reported, \emph{i.e.}
the ordinal number of the sequence within the ordered set of sequences
(\Rcode{sequence} column) and the start position of the pattern within that 
sequence (\Rcode{position} column) are returned in the resulting 
\Rcode{data.frame}.

Similarly, the matrix of PWM scanning scores along all sequences can be
obtained using \Rcode{motifScanScores} function:
<<>>=
scanScores <- motifScanScores(regionsSeq = zebrafishPromotersTSSflankSeq[1:50], 
            motifPWM = TBPpwm, seqOrder = 
            order(zebrafishPromotersTSSflank$interquantileWidth[1:50]))
dim(scanScores)
scanScores[1:6,1:6]
@
By default, the values corresponding to the percentage of the maximal possible 
PWM score are returned.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Session Info}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
<<>>=
sessionInfo()
@

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\bibliography{seqPattern}
\end{document}

\name{plotMotifScanScores}
\docType{methods}
\alias{plotMotifScanScores}
\alias{plotMotifScanScores,DNAStringSet,matrix-method}
\title{Plotting heatmap of motif scanning scores}
\description{
Plots heatmap of motif scanning scores for a set of sorted sequences of the
same length in the form of a two dimensional map centered at a common reference
position. Motif is specified by a position weight matrix (PWM) that contains
estimated probability of base b at position i, and the percentage of the
maximal PWM score is plotted for each position (nucleotide) in each sequence.
}
\usage{
plotMotifScanScores(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, xTicks = NULL, xTicksAt = NULL,
    xLabel = "", yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8,
    plotScale = TRUE, scaleLength = NULL, scaleWidth = 15,
    addReferenceLine = TRUE, plotColorLegend = TRUE, outFile =
    "MotifScanningScores.png", plotWidth = 2000, plotHeight = 2000)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        for which the motif occurrence density should be visualised.
    }
    \item{motifPWM}{
        A numeric matrix representing the Position Weight Matrix (PWM), such as
        returned by \code{\link{PWM}} function. Can contain either probabilities
        or log2 probability ratio of base b at position i.
    }
    \item{seqOrder}{
        Integer vector specifying the order of the provided input sequences.
        Must have the same length as the number of sequences in the
        \code{regionSeq}. Input sequences will be sorted according to this index
        in an ascending order form top to the bottom of the plot, \emph{i.e.}
        the sequence labeled with the lowest number will appear at the top of
        the plot. The default value will order the sequences as they are ordered
        in the input \code{regionSeq} object.
    }
    \item{flankUp, flankDown}{
        The number of base-pairs upstream and downstream of the reference
        position in the provided sequences, respectively.
        \code{flankUp + flankDown} must sum up to the length of the sequences.
    }
    \item{xTicks}{
        Character vector of labels to be placed at the tick-marks on x-axis.
        The default \code{NULL} value produces five tick-marks: one at the
        reference point and two equally spaced tick-marks both upstream and
        downstream of the reference point.
    }
    \item{xTicksAt}{
        Numeric vector of positions of the tick-marks on the x-axis. The values
        can range from 1 (the position of the first base-pair in the sequence)
        to input sequence length. The default \code{NULL} value produces five
        tick-marks: one at the reference point and two equally spaced tick-marks
        both upstream and downstream of the reference point.
    }
    \item{xLabel}{
        The label for the x-axis. The default is no label, \emph{i.e.} empty
        string.
    }
    \item{yTicks}{
        Character vector of labels to be placed at the tick-marks on y-axis.
        The default \code{NULL} value produces no tick-marks and labels.
    }
    \item{yTicksAt}{
        Numeric vector of positions of the tick-marks on the y-axis. The values
        can range from 1 (the position of the last sequence on the bottom of the
        plot) to input sequence length (the position of the first sequence on
        the top of the plot). The default \code{NULL} value produces no
        tick-marks.
    }
    \item{yLabel}{
        The label for the y-axis. The default is no label, \emph{i.e.} empty
        string.
    }
    \item{cexAxis}{
        The magnification to be used for axis annotation.
    }
    \item{plotScale}{
        Logical, should the scale bar be plotted in the lower left corner of
        the plot.
    }
    \item{scaleLength}{
        The length of the scale bar to be plotted. Used only when
        \code{plotScale = TRUE}. If no value is provided, it defaults to one
        fifth of the input sequence length.
    }
    \item{scaleWidth}{
        The width of the line for the scale bar. Used only when
        \code{plotScale = TRUE}.
    }
    \item{addReferenceLine}{
        Logical, should the vertical dashed line be drawn at the reference
        point.
    }
    \item{plotColorLegend}{
        Logical, should the color legend for the scanning score be plotted on
        the right side of the plot.
    }
    \item{outFile}{
        Character vector specifying the base name of the output plot file. The
        final name of the plot file for each pattern will be
        \code{outFile}."pattern.jpg".
    }
    \item{plotWidth, plotHeight}{
        Width and height of the density plot in pixels.
    }
}

\value{
    The function produces a PNG file in the working directory, visualising motif
    scanning scores in the set of ordered input sequences.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{motifScanScores}}
    \cr
    \code{\link{plotPatternDensityMap}}
}
\examples{
library(GenomicRanges)
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))
promoterWidth <- elementMetadata(zebrafishPromoters)$interquantileWidth

load(system.file("data", "TBPpwm.RData", package="seqPattern"))

plotMotifScanScores(regionsSeq=zebrafishPromoters, motifPWM = TBPpwm,
        seqOrder=order(promoterWidth), flankUp = 400, flankDown = 600)
}

\name{getPatternOccurrenceList}
\docType{methods}
\alias{getPatternOccurrenceList}
\alias{getPatternOccurrenceList,DNAStringSet-method}
\title{Occurrence of sequence patterns in a set of ordered sequences}
\description{
Finds positions of specified sequence patterns in a list of sequences of the
same length ordered by a provided index. Sequence patterns can be consensus
sequences of variable length and can contain IUPAC ambiguity code. Position of
each pattern occurrence is specified in two-dimensional matrix, \emph{i.e.} the
first coordinate provides the ordinal number of the sequence and the second
coordinate gives the position within the sequence where the pattern occurs.
}
\usage{
getPatternOccurrenceList(regionsSeq, patterns, seqOrder =
        c(1:length(regionsSeq)), useMulticore = FALSE, nrCores = NULL)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        in which to search for the patterns.
    }
    \item{patterns}{
        Character vector specifying one or more DNA sequence patterns
        (oligonucleotides). IUPAC ambiguity codes can be used and will match any
        letter in the subject that is associated with the code.
    }
    \item{seqOrder}{
        Integer vector specifying the order of the provided input sequences.
        Must have the same length as the number of sequences in the
        \code{regionSeq}. The default value will order the sequences as they are
        ordered in the \code{regionSeq} object.
    }
    \item{useMulticore}{
        Logical, should multicore be used. \code{useMulticore = TRUE} is
        supported only on Unix-like platforms.
    }
    \item{nrCores}{
        Number of cores to use when \code{useMulticore = TRUE}. Default value
        \code{NULL} uses all detected cores.
    }
}
\details{
    This function uses the \code{\link{matchPattern}} function to find
    occurrences of given sequence patterns in a set of input sequences.
    Input sequences must all be of the same length and are ordered according to
    the index provided in the \code{seqOrder} argument, creating a \code{n * m}
    matrix, where \code{n} is the number of sequences and \code{m} is the length
    of the sequences. Positions of pattern matches in the resulting matrix are
    returned as two-dimensional coordinates.
}
\value{
    The function returns a named list with one element for each sequence pattern
    specified in the \code{patterns} argument. Each element of the list is a
    \code{data.frame} with positions of the corresponding pattern in the set of
    input sequences. The input sequences of the same length are sorted according
    to the index in \code{seqOrder} argument and the positions of pattern
    matches in the resulting \code{n * m} matrix (where \code{n} is the number
    of sequences and \code{m} is the length of the sequence) are provided. The
    \code{sequence} column in the data.frame provides the ordinal number of the
    sequence in the ordered list of sequences and the \code{position} column
    provides the start position of the pattern match within that sequence.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{plotPatternDensityMap}}
    \cr
    \code{\link{motifScanHits}}
}
\examples{
library(GenomicRanges)
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))
promoterWidth <- elementMetadata(zebrafishPromoters)$interquantileWidth

# dinucleotide patterns
patternsOccurrence <- getPatternOccurrenceList(regionsSeq = zebrafishPromoters,
                    patterns = c("TA", "GC"), seqOrder = order(promoterWidth))
names(patternsOccurrence)
head(patternsOccurrence[["GC"]])

# motif consensus sequence
patternsOccurrence <- getPatternOccurrenceList(regionsSeq = zebrafishPromoters,
                    patterns = "TATAWAWR", seqOrder = order(promoterWidth))
names(patternsOccurrence)
head(patternsOccurrence[["TATAWAWR"]])
}

\name{zebrafishPromoters}
\docType{data}
\alias{zebrafishPromoters}
\title{Zebrafish promoters sequences}
\description{
This is a \code{\link{DNAStringSet}} object that contains sequence of 1000 
randomly selected promoters active in 24 hpf zebrafish \emph{Danio rerio} 
embryos. The data is taken from Nepal \emph{et al.} Genome Research 2013, and 
represents regions flanking 400 bp upstream and 600 bp downstream of the 
dominant TSS detected by Cap analysis of gene expression (CAGE). It is intended 
to be used as an input data in running examples from \code{\link{seqPattern}} 
package help pages.
}
\usage{data(zebrafishPromoters)}
\value{A \code{\link{DNAStringSet}} object}
\format{A \code{\link{DNAStringSet}} object}
\keyword{datasets}
\references{
Nepal \emph{et al.} (2013) Dynamic regulation of the transcription initiation 
landscape at single nucleotide resolution during vertebrate embryogenesis, 
\emph{Genome Research} \bold{23}(11):1938-1950.
}

\name{seqPattern-package}
\alias{seqPattern-package}
\alias{seqPattern}
\docType{package}
\title{Visualising oligonucleotide patterns and motif occurences across a set
of ordered sequences}
\description{
Visualising oligonucleotide patterns and sequence motifs occurrences across a 
large set of sequences centred at a common reference point and sorted by a user 
defined feature.
}
\details{
\tabular{ll}{
Package: \tab SeqPattern\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2014-12-05\cr
License: \tab GPL-3\cr
Depends: \tab R (>= 3.0.1), methods\cr
}
}
\author{
Vanja Haberle

Maintainer: Vanja Haberle <vanja.haberle@gmail.com>
}
\keyword{ package }

\name{plotPatternDensityMap}
\docType{methods}
\alias{plotPatternDensityMap}
\alias{plotPatternDensityMap,DNAStringSet-method}
\title{Plotting density maps of sequence pattern occurrence}
\description{
Plots density of sequence pattern occurrences in an ordered set of sequences of
the same length in the form of a two dimensional map centered at a common
reference position. Multiple sequence patterns can be processed at once and one
plot per pattern will be created with the same color scale across all plots,
allowing visual density comparison across different patterns.
}
\usage{
plotPatternDensityMap(regionsSeq, patterns, seqOrder = c(1:length(regionsSeq)),
    flankUp = NULL, flankDown = NULL, nBin = NULL, bandWidth = NULL, 
    color = "blue", transf = NULL, xTicks = NULL, xTicksAt = NULL, xLabel = "", 
    yTicks = NULL, yTicksAt = NULL, yLabel = "", cexAxis = 8, plotScale = TRUE,
    scaleLength = NULL, scaleWidth = 15, addPatternLabel = TRUE, cexLabel = 8,
    labelCol = "black", addReferenceLine = TRUE, plotColorLegend = TRUE,
    outFile = "PatternDensityMap", plotWidth = 2000, plotHeight = 2000,
    useMulticore = FALSE, nrCores = NULL)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        for which the patterns occurrence density should be visualised.
    }
    \item{patterns}{
        Character vector specifying one or more DNA sequence patterns
        (oligonucleotides). IUPAC ambiguity codes can be used and will match any
        letter in the subject that is associated with the code.
    }
    \item{seqOrder}{
        Integer vector specifying the order of the provided input sequences.
        Must have the same length as the number of sequences in the
        \code{regionSeq}. Input sequences will be sorted according to this index
        in an ascending order form top to the bottom of the plot, \emph{i.e.}
        the sequence labeled with the lowest number will appear at the top of
        the plot. The default value will order the sequences as they are ordered
        in the input \code{regionSeq} object.
    }
    \item{flankUp, flankDown}{
        The number of base-pairs upstream and downstream of the reference
        position in the provided sequences, respectively.
        \code{flankUp + flankDown} must sum up to the length of the sequences. 
        If no values are provided both \code{flankUp} and \code{flankDown} are 
        set to be half of the length of the input sequences, \emph{i.e.} the 
        reference position is assumed to be in the middle of the sequences.
    }
    \item{nBin}{
        Numeric vector with two values containing the number of equally spaced
        points in each direction over which the density is to be estimated. The
        first value specifies number of bins along x-axis, i.e. along the
        nucleotides in the sequence, and the second value specifies the number
        of bins along y-axis, i.e. across ordered input sequences. The values
        are passed on to the \code{gridsize} argument of the
        \code{\link{bkde2D}} function to compute a 2D binned kernel density
        estimate. If \code{nBin} is not specified it will default to
        \code{c(n, m)}, where \code{n} is the number of input sequences and
        \code{m} is the length of sequences.
    }
    \item{bandWidth}{
        Numeric vector of length 2, containing the bandwidth to be used in each
        coordinate direction. The first value specifies the bandwidth along the
        x-axis, \emph{i.e.} along the nucleotides in the sequence, and the
        second value specifies the bandwidth along y-axis, \emph{i.e.} across
        ordered input sequences. The values are passed on to the
        \code{bandwidth} argument of the \code{\link{bkde2D}} function to
        compute a 2D binned kernel density estimate and are used as standard
        deviation of the bivariate Gaussian kernel. If \code{bandWidth} is not
        specified it will default to \code{c(3,3)}.
    }
    \item{color}{
        Character specifying the color palette for the density plot. One of the 
        following color palettes can be specified: \code{"blue", "brown", 
        "cyan", "gold", "gray", "green", "pink", "purple", "red"}. Please refer 
        to the vignette for the appearance of these palettes.
    }
    \item{transf}{
        The function mapping the density scale to the color scale. See Details.
    }
    \item{xTicks}{
        Character vector of labels to be placed at the tick-marks on x-axis.
        The default \code{NULL} value produces five tick-marks: one at the
        reference point and two equally spaced tick-marks both upstream and
        downstream of the reference point.
    }
    \item{xTicksAt}{
        Numeric vector of positions of the tick-marks on the x-axis. The values
        can range from 1 (the position of the first base-pair in the sequence)
        to input sequence length. The default \code{NULL} value produces five
        tick-marks: one at the reference point and two equally spaced tick-marks
        both upstream and downstream of the reference point.
    }
    \item{xLabel}{
        The label for the x-axis. The default is no label, \emph{i.e.} empty
        string.
    }
    \item{yTicks}{
        Character vector of labels to be placed at the tick-marks on y-axis.
        The default \code{NULL} value produces no tick-marks and labels.
    }
    \item{yTicksAt}{
        Numeric vector of positions of the tick-marks on the y-axis. The values
        can range from 1 (the position of the last sequence on the bottom of the
        plot) to input sequence length (the position of the first sequence on
        the top of the plot). The default \code{NULL} value produces no
        tick-marks.
    }
    \item{yLabel}{
        The label for the y-axis. The default is no label, \emph{i.e.} empty
        string.
    }
    \item{cexAxis}{
        The magnification to be used for axis annotation.
    }
    \item{plotScale}{
        Logical, should the scale bar be plotted in the lower left corner of
        the plot.
    }
    \item{scaleLength}{
        The length of the scale bar to be plotted. Used only when
        \code{plotScale = TRUE}. If no value is provided, it defaults to one
        fifth of the input sequence length.
    }
    \item{scaleWidth}{
        The width of the line for the scale bar. Used only when
        \code{plotScale = TRUE}.
    }
    \item{addPatternLabel}{
        Logical, should the pattern label be written in the upper left corner
        of the plot.
    }
    \item{cexLabel}{
        The magnification to be used for pattern label.
    }
    \item{labelCol}{
        The color to be used for pattern label and scale bar.
    }
    \item{addReferenceLine}{
        Logical, should the vertical dashed line be drawn at the reference
        point.
    }
    \item{plotColorLegend}{
        Logical, should the color legend for the pattern density be plotted. If
        \code{TRUE} a separate .png file named \code{outFile}."ColorLegend.png"
        will be created, showing mapping of pattern density values to colours.
    }
    \item{outFile}{
        Character vector specifying the base name of the output plot file. The
        final name of the plot file for each pattern will be
        \code{outFile}."pattern.png".
    }
    \item{plotWidth, plotHeight}{
        Width and height of the density plot(s) in pixels.
    }
    \item{useMulticore}{
        Logical, should multicore be used. \code{useMulticore = TRUE} is
        supported only on Unix-like platforms.
    }
    \item{nrCores}{
        Number of cores to use when \code{useMulticore = TRUE}.  Default value
        \code{NULL} uses all detected cores.
    }
}
\value{
    The function produces PNG files in the working directory, visualising
    density of patterns occurrence in the set of ordered input sequences. One
    file/plot per specified pattern is created.
}
\references{
    Haberle \emph{et al.} (2014) Two independent transcription initiation codes
    overlap on vertebrate core promoters, \emph{Nature} \bold{507}:381-385.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{getPatternOccurrenceList}}
    \cr
    \code{\link{plotMotifDensityMap}}
}
\examples{
library(GenomicRanges)
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))

promoterWidth <- elementMetadata(zebrafishPromoters)$interquantileWidth

# dinucleotide patterns
plotPatternDensityMap(regionsSeq = zebrafishPromoters, patterns = c("TA", "GC"),
            seqOrder = order(promoterWidth), flankUp = 400, flankDown = 600, 
            color = "blue")

# motif consensus sequence
plotPatternDensityMap(regionsSeq = zebrafishPromoters, patterns = "TATAWAWR",
            seqOrder = order(promoterWidth), flankUp = 400, flankDown = 600,
            color = "cyan")
}

\name{TBPpwm}
\docType{data}
\alias{TBPpwm}
\title{Position-weight matrix for TATA-box binding protein motif}
\description{
This is a \code{\link{matrix}} object representing a position-weight matrix 
(PWM) for TATA-box binding protein motif. The scores in the matrix correspond
to log2 ratio between probability of observing base b (rows) at position i
(columns) and background probability of base b. This PWM has been derived using 
position frequency matrix from Jaspar database. It is intended to be used as an 
input data in running examples from \code{\link{seqPattern}} package help pages.
}
\usage{data(TBPpwm)}
\value{A \code{\link{matrix}} object}
\format{A \code{\link{matrix}} object}
\keyword{datasets}

\name{plotPatternOccurrenceAverage}
\docType{methods}
\alias{plotPatternOccurrenceAverage}
\alias{plotPatternOccurrenceAverage,DNAStringSet-method}
\title{Plotting average profile of sequence pattern occurrence}
\description{
Plots average profile of sequence pattern occurrence for a set of input sequences of the same length. Multiple sequence patterns can be processed at once and visualised in the same plot, allowing comparison across different patterns.
}
\usage{
plotPatternOccurrenceAverage(regionsSeq, patterns, flankUp = NULL, 
    flankDown = NULL, smoothingWindow = 1, color = rainbow(length(patterns)),
    xLabel = "Distance to reference point (bp)", yLabel = "Relative frequency",
    cexAxis = 1, addReferenceLine = TRUE, plotLegend = TRUE, cexLegend = 1,
    useMulticore = FALSE, nrCores = NULL, add = FALSE, ...)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        for which the patterns occurrence profile should be visualised.
    }
    \item{patterns}{
        Character vector specifying one or more DNA sequence patterns
        (oligonucleotides). IUPAC ambiguity codes can be used and will match any
        letter in the subject that is associated with the code.
    }
    \item{flankUp, flankDown}{
        The number of base-pairs upstream and downstream of the reference
        position in the provided sequences, respectively.
        \code{flankUp + flankDown} must sum up to the length of the sequences. 
        If no values are provided both \code{flankUp} and \code{flankDown} are 
        set to be half of the length of the input sequences, \emph{i.e.} the 
        reference position is assumed to be in the middle of the sequences.
    }
    \item{smoothingWindow}{
        Integer specifying the size of a window (in base-pairs) to be used for 
        smoothing the signal. Default value of 1 corresponds to no smoothing.
    }
    \item{color}{
        A vector of values specifying the colors for plotting. Number of colors
        must match the number of patterns that should be plotted.
    }
    \item{xLabel, yLabel}{
        Character strings for x and y axis labels, respectively.
    }
    \item{cexAxis}{
        The magnification to be used for axis annotation relative to the current 
        setting of \code{cex}.
    }
    \item{addReferenceLine}{
        Logical, should the vertical dashed line be drawn at the reference
        point.
    }
    \item{plotLegend}{
        Logical, should the legend be plotted at the top.
    }
    \item{cexLegend}{
        The magnification to be used for legend relative to the current setting 
        of \code{cex}.
    }
    \item{useMulticore}{
        Logical, should multicore be used. \code{useMulticore = TRUE} is
        supported only on Unix-like platforms.
    }
    \item{nrCores}{
        Number of cores to use when \code{useMulticore = TRUE}.  Default value
        \code{NULL} uses all detected cores.
    }
    \item{add}{
        Logical, should the pattern occurrence profiles be added to the existing 
        plot.
    }
    \item{...}{
        Further arguments to be passed to \code{plot()} or \code{lines()} 
        methods, such as \code{lty}, \emph{etc}.
    }
}
\value{
    The function finds all hits matching the specified patterns in the set of 
    input sequences and plots one average profile per pattern reflecting the 
    occurrence of patterns across sequences.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{getPatternOccurrenceList}}
    \cr
    \code{\link{plotPatternDensityMap}}
}
\examples{
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))

# dinucleotide patterns
plotPatternOccurrenceAverage(regionsSeq = zebrafishPromoters, patterns = c("AT", 
            "TA", "CG", "GC"), flankUp = 400, flankDown = 600, smoothingWindow = 
            3, color = c("gold", "darkred", "forestgreen", "navy"))

# motif consensus sequence
plotPatternOccurrenceAverage(regionsSeq = zebrafishPromoters, patterns = 
            "TATAWAWR", flankUp = 400, flankDown = 600, smoothingWindow = 3, 
            color = "gray")
}

\name{zebrafishPromoters24h}
\docType{data}
\alias{zebrafishPromoters24h}
\title{Zebrafish promoters genomic coordinates}
\description{
This is a \code{\link{data.frame}} object that contains genomic coordinates of 
12078 promoters active in zebrafish \emph{Danio rerio} embryos at 24 hours past 
fertilisation. For each promoter additional information is provided, including 
position of the dominant (most frequently used) TSS position, number of CAGE 
tags per million supporting that promoter and the interquantile width of the 
promoter (width of the central region containing >= 80\% of the CAGE tags). The 
data is taken from Nepal \emph{et al.} Genome Research 2013, and it is intended 
to be used for running examples from \code{\link{seqPattern}} package vignette.
}
\usage{data(zebrafishPromoters24h)}
\value{A \code{\link{data.frame}} object}
\format{A \code{\link{data.frame}} object}
\keyword{datasets}
\references{
Nepal \emph{et al.} (2013) Dynamic regulation of the transcription initiation 
landscape at single nucleotide resolution during vertebrate embryogenesis, 
\emph{Genome Research} \bold{23}(11):1938-1950.
}

\name{motifScanHits}
\docType{methods}
\alias{motifScanHits}
\alias{motifScanHits,DNAStringSet,matrix-method}
\title{Occurrence of motifs in a set of ordered sequences}
\description{
Finds positions of sequence motif hits above a specified threshold in a list of
sequences of the same length ordered by a provided index. Motif is specified by
a position weight matrix (PWM) that contains estimated probability of base b at
position i and is usually constructed via call to \code{\link{PWM}} function.
Position of each motif hit is specified in two-dimensional matrix, \emph{i.e.}
the first coordinate provides the ordinal number of the sequence and the second
coordinate gives the position within the sequence where the motif occurs.
}
\usage{
motifScanHits(regionsSeq, motifPWM, minScore = "80\%",
    seqOrder = c(1:length(regionsSeq)))
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        in which to search for the motif hits.
    }
    \item{motifPWM}{
        A numeric matrix representing the Position Weight Matrix (PWM), such as
        returned by \code{\link{PWM}} function. Can contain either probabilities
        or log2 probability ratio of base b at position i.
    }
    \item{minScore}{
        The minimum score for counting a motif hit. Can be given as a character
        string containing a percentage (\emph{e.g.} \code{"85\%"}) of the
        PWM score or a single number specifying score threshold. If a percentage
        is given, it is converted to a score value taking into account both
        minimal and maximal possible PWM scores as follows:
        \code{minPWMscore + percThreshold/100 * (maxPWMscore - minPWMscore)}
        This differs from the formula in the \code{\link{matchPWM}} function
        from the \code{Biostrings} package which takes into account only the 
        maximal possible PWM score and considers the given percentage as the 
        percentage of that maximal score:
        \code{percThreshold/100 * maxPWMscore}
    }
    \item{seqOrder}{
        Integer vector specifying the order of the provided input sequences.
        Must have the same length as the number of sequences in the
        \code{regionSeq}. The default value will order the sequences as they are
        ordered in the input \code{regionSeq} object.
    }
}
\details{
    This function uses the \code{\link{matchPWM}} function to find matches to
    given motif in a set of input sequences. Only matches above specified
    \code{minScore} are considered as hits. Input sequences must all be of the
    same length and are ordered according to the index provided in the
    \code{seqOrder} argument, creating a \code{n * m} matrix, where \code{n} is
    the number of sequences and \code{m} is the length of the sequences.
    Positions of motif hits in the resulting matrix are returned as
    two-dimensional coordinates.
}
\value{
    The function returns a \code{data.frame} with positions of the motif hits in
    the set of input sequences. The input sequences of the same length are
    sorted according to the index in \code{seqOrder} argument and the positions
    of motif hits in the resulting \code{n * m} matrix (where \code{n} is the
    number of sequences and \code{m} is the length of the sequence) are
    provided. The \code{sequence} column in the data.frame provides the ordinal
    number of the sequence in the ordered list of sequences and the
    \code{position} column provides the start position of the motif hit within
    that sequence.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{plotMotifDensityMap}}
    \cr
    \code{\link{getPatternOccurrenceList}}
}
\examples{
library(GenomicRanges)
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))
promoterWidth <- elementMetadata(zebrafishPromoters)$interquantileWidth

load(system.file("data", "TBPpwm.RData", package="seqPattern"))

motifOccurrence <- motifScanHits(regionsSeq = zebrafishPromoters,
                                motifPWM = TBPpwm, minScore = "85\%",
                                seqOrder = order(promoterWidth))
head(motifOccurrence)
}

\name{motifScanScores}
\docType{methods}
\alias{motifScanScores}
\alias{motifScanScores,DNAStringSet,matrix-method}
\title{Motif scanning scores for a set of ordered sequences}
\description{
Provides motif scanning scores along the full length of a sequence for a list
of sequences of the same length ordered by a provided index. Motif is specified
by a position weight matrix (PWM) that contains estimated probability of base b
at position i and is usually constructed via call to \code{\link{PWM}} function.
Scanning scores are returned in the form of a two-dimensional matrix, where the
rows are sequences ordered by the specified index and the columns are relative
positions within the sequence. Each cell in the matrix contains the score of
the specified motif in the given sequence starting at the given position. The
resulting matrix can be used to visualise motif occurrences and their strength
in an ordered set of sequences centered at a common reference point.
}
\usage{
motifScanScores(regionsSeq, motifPWM, seqOrder = c(1:length(regionsSeq)),
        asPercentage = TRUE)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        to be scanned with the motif.
    }
    \item{motifPWM}{
        A numeric matrix representing the Position Weight Matrix (PWM), such as
        returned by \code{\link{PWM}} function. Can contain either probabilities
        or log2 probability ratio of base b at position i.
    }
    \item{seqOrder}{
        Integer vector specifying the order of the provided input sequences.
        Must have the same length as the number of sequences in the
        \code{regionSeq}. The default value will order the sequences as they are
        ordered in the input \code{regionSeq} object.
    }
    \item{asPercentage}{
        Logical, should the scores represent percentage of the maximal motif PWM
        score (\code{TRUE}) or raw scores (\code{FALSE}).
    }
}
\details{
    This function uses the \code{\link{PWMscoreStartingAt}} function to get
    scores for a given motif starting at each position (nucleotide) in a set of
    input sequences. Input sequences must all be of the same length and are
    ordered according to the index provided in the \code{seqOrder} argument,
    creating an \code{n * m} matrix, where \code{n} is the number of sequences
    and \code{m} is the length of the sequences. Each cell in the matrix
    contains the score of the specified motif in the given sequence starting at
    the given position.
}
\value{
    The function returns a \code{matrix} with motif scanning scores for each
    position in the set of input sequences.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{plotMotifScanScores}}
    \cr
    \code{\link{motifScanHits}}
}
\examples{
library(GenomicRanges)
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))
promoterWidth <- elementMetadata(zebrafishPromoters)$interquantileWidth

load(system.file("data", "TBPpwm.RData", package="seqPattern"))

motifScores <- motifScanScores(regionsSeq = zebrafishPromoters,
                            motifPWM = TBPpwm, seqOrder = order(promoterWidth),
                            asPercentage = TRUE)
dim(motifScores)
motifScores[1:10,1:10]
}

\name{plotMotifOccurrenceAverage}
\docType{methods}
\alias{plotMotifOccurrenceAverage}
\alias{plotMotifOccurrenceAverage,DNAStringSet,matrix-method}
\title{Plotting average profile of motif occurrence}
\description{
Plots average profile of motif occurrence for a set of input sequences of the
same length. Motif is specified by a position weight matrix (PWM) that contains
estimated probability of base b at position i, and only motif hits above
specified threshold are taken into account.
}
\usage{
plotMotifOccurrenceAverage(regionsSeq, motifPWM, minScore = "80\%", flankUp = 
    NULL, flankDown = NULL, smoothingWindow = 1, color = "black", xLabel = 
    "Distance to reference point (bp)", yLabel = "Relative frequency", cexAxis = 
    1, addReferenceLine = TRUE, plotLegend = FALSE, cexLegend = 1, add = FALSE, 
    ...)
}
\arguments{
    \item{regionsSeq}{
        A \code{\link{DNAStringSet}} object. Set of sequences of the same length
        for which the patterns occurrence profile should be visualised.
    }
    \item{motifPWM}{
        A numeric matrix representing the Position Weight Matrix (PWM), such as
        returned by \code{\link{PWM}} function. Can contain either probabilities
        or log2 probability ratio of base b at position i.
    }
    \item{minScore}{
        The minimum score for counting a motif hit. Can be given as a character
        string containing a percentage (\emph{e.g.} \code{"85\%"}) of the
        PWM score or a single number specifying score threshold. If a percentage
        is given, it is converted to a score value taking into account both
        minimal and maximal possible PWM scores as follows:
        \code{minPWMscore + percThreshold/100 * (maxPWMscore - minPWMscore)}
        This differs from the formula in the \code{\link{matchPWM}} function
        from the \code{Biostrings} package which takes into account only the 
        maximal possible PWM score and considers the given percentage as the 
        percentage of that maximal score:
        \code{percThreshold/100 * maxPWMscore}
    }
    \item{flankUp, flankDown}{
        The number of base-pairs upstream and downstream of the reference
        position in the provided sequences, respectively.
        \code{flankUp + flankDown} must sum up to the length of the sequences. 
        If no values are provided both \code{flankUp} and \code{flankDown} are 
        set to be half of the length of the input sequences, \emph{i.e.} the 
        reference position is assumed to be in the middle of the sequences.
    }
    \item{smoothingWindow}{
        Integer specifying the size of a window (in base-pairs) to be used for 
        smoothing the signal. Default value of 1 corresponds to no smoothing.
    }
    \item{color}{
        Value specifying the color for plotting.
    }
    \item{xLabel, yLabel}{
        Character strings for x and y axis labels, respectively.
    }
    \item{cexAxis}{
        The magnification to be used for axis annotation relative to the current 
        setting of \code{cex}.
    }
    \item{addReferenceLine}{
        Logical, should the vertical dashed line be drawn at the reference
        point.
    }
    \item{plotLegend}{
        Logical, should the legend be plotted at the top.
    }
    \item{cexLegend}{
        The magnification to be used for legend relative to the current setting 
        of \code{cex}.
    }
    \item{add}{
        Logical, should the pattern occurrence profiles be added to the existing 
        plot.
    }
    \item{...}{
        Further arguments to be passed to \code{plot()} or \code{lines()} 
        methods, such as \code{lty}, \emph{etc}.
    }
}
\value{
    The function finds all hits matching the motif above the specified score    
    threshold in the set of input sequences and plots an average profile 
    reflecting the occurrence of the motif across input sequences.
}
\author{Vanja Haberle}

\seealso{
    \code{\link{motifScanHits}}
    \cr
    \code{\link{plotMotifDensityMap}}
}
\examples{
load(system.file("data", "zebrafishPromoters.RData", package="seqPattern"))
load(system.file("data", "TBPpwm.RData", package="seqPattern"))

plotMotifOccurrenceAverage(regionsSeq = zebrafishPromoters, motifPWM = TBPpwm,
                    minScore = "85\%", flankUp = 400, flankDown = 600, 
                    smoothingWindow = 3)
}
